/*
this code under free to learn and exploration use,
there is covered GNU/GPL3 (as part of j4l no-care restrictions, just idea), with j4l restrictions:
you can modify, but not redist as anything, what that is not cost.
be ready for carmic destruction.
there is no way to cover obfusc on it - there is big question of life, universe and something other etc.
you can use it on production, with all over you modifications, you can install it for any non-commercial structures,
or with mailing to lostbyte32@gmail.com, with words: 'we want it', and take any representable answer for "why".
code is free to use, learn and research.

code redistutable as it and nobody care, for free exactly? with free to use, but with original link or hand-to-hand redistribution.
j4l 0.0.4 Common Annual Part Restrictions And No Cares Waranty Happens, self-licensed and as it 04.11.2023
*/
if (document.readyState == "loading") {
    cache();
}
function cache() {
    let path = window.location.pathname.split('/');
    let query = path[path.length - 1];

    let page = parseInt(query);
    if (!page)
        page = 1;
    window.store = new StorageManagerEx();
    window.store.checkForUpdate(page);
}

function install_require_check() {
    const admin = document.getElementsByName('admin_user')[0];
    const admin_pass = document.getElementsByName('admin_pass')[0];
    const host = document.getElementsByName('host')[0];
    const admin_confirm = document.getElementsByName('admin_confirm')[0];
    const user = document.getElementsByName('user')[0];
    const port = document.getElementsByName('port')[0];
    const database = document.getElementsByName('database')[0];
    const pass = document.getElementsByName('pass')[0];
    return { 'admin': admin, 'admin_pass': admin_pass, 'pass': pass, 'host': host, 'admin_confirm': admin_confirm, 'user': user, 'port': port, 'database': database };
}

function install_type(e) {
    if (e.target.value) {
        let array = Object.values(install_require_check());
        switch (e.target.value) {
            case 'Mysql':
                {
                    StorageManagerEx.setCookie('install', 'mysql', 1);
                    array.forEach(element => {
                        element.style.display = "block";
                    });
                }
                break;
            case 'static':
                {
                    StorageManagerEx.setCookie('install', 'static', 1);

                    array.forEach(element => {
                        element.style.display = "none";
                    });
                }
                break;
        }
    }
}

function getProtocol() {
    const protocolName = window.location.protocol;
    return protocolName;
}

function getPath() {
    const protocol = getProtocol();
    let buildString = protocol + ':'
}

function hideImages() {
    let images = document.getElementsByTagName('img');
    for (let img of images) {
        const need = img.parentElement.getAttribute('id');
        if (!need)
            img.style.display = "none";
    }
    const pagination = document.querySelector('.pagination-wrapper');
    if (pagination)
        pagination.style.display = "none";

    const nav = document.getElementsByTagName('nav');
    if (nav[0]) {
        nav[0].style.display = "none";
    }

    const disabler = document.getElementById('disabler');
    if (disabler)
        disabler.style.display = "none";
}

function check_install(el) {
    let host, port, user, pass, base;
    let install = StorageManagerEx.get_cookie('install');
    var data = new FormData();
    for (let x = 0; x < el.parentElement.children.length; x++) {
        let elem = el.parentElement.children[x];
        if (!elem)
            continue;
        let name, value;
        if (elem && elem.name) {
            name = elem.name;
            value = elem.value;
        }
        if (name && value) {
            data.append(name, value);
        }
    }
    data.append('install', install);
    var xhttp = new XMLHttpRequest();
    xhttp.open("POST", "/внедрить/finish", true);
    xhttp.onreadystatechange = function () {
        if (this.readyState == 4 && this.status == 200) {
            var response = this.responseText;
            if (response == 'done') {
                window.location.replace('/');
            }
        }
    };
    xhttp.send(data);
    //console.table(host, port, user, pass, base);
}

function isJsonString(str) {
    try {
        JSON.parse(str);
    } catch (e) {
        return false;
    }
    return true;
}

function adjust_textarea(h) {
    h.style.height = "20px";
    h.style.height = (h.scrollHeight) + "px";
}


function handleCopyText(data) {
    const cb = navigator.clipboard;
    cb.writeText(data).then(() => alert('Скопировано'));
}
function copyToClipboard(text) {
    window.prompt("Скопируйте текст", text);
}
function checktext() {
    const el = document.querySelector('.highLite_editable');
    console.log(el.textContent);
}


function upload_file(e) {
    const crsf = document.getElementsByName('crsf_token')[0].value;
    var formData = new FormData();
    formData.append("crsf_token", crsf);
    if (!e.parentElement.children[1])
        return;
    let files = e.parentElement.children[1].files;
    const responseplace = document.createElement('div');
    responseplace.setAttribute('id', 'response');
    e.parentElement.appendChild(responseplace);
    if (files) {
        let count = 0;
        for (let file of files) {
            formData.append('file_' + count, file);
            count++;
        }
        var xhttp = new XMLHttpRequest();
        xhttp.open("POST", "/залив", true);
        xhttp.onreadystatechange = function () {
            if (this.readyState == 4 && this.status == 200) {
                var response = JSON.parse(this.responseText);
                const res = parseInt(response.res);
                switch (res) {
                    case Enums.FILE_UPLOAD_DONE:
                        {
                            responseplace.innerHTML += response.file + "<br>";
                        }
                        break;
                }
            }
        };
        xhttp.send(formData);
    }
}

document.addEventListener("DOMContentLoaded", function () {
    if (window.store) {
        window.store.install();
    }
    if (document.readyState == "interactive") {
        const forms = document.getElementsByTagName('form');
        for (const form of forms) {
            let editor = new Editor(form);
        }
        var observer = new IntersectionObserver(function (entries) {
            if (entries[0].isIntersecting === true) {

            }
        }, { threshold: [1] });
    }
});

function editor_update() {
    const editor = getEditorElement();
    let editor_preview = document.getElementById('editor-preview');
    if (!editor_preview || !editor)
        return;
    const iHTML = editor.value;
    const doc = editor_preview.contentDocument;
    doc.open();
    doc.write(iHTML);
    doc.close();
    doc.designMode = "on";
}
function convertBlobToDataUrl(blob, cb) {
    var reader = new FileReader();
    reader.readAsDataURL(blob);
    reader.onloadend = function () {
        return cb(null, reader.result)
    };
}

function post_guest(t) {
    var xhttp = new XMLHttpRequest();
    xhttp.open("POST", "/гостевая", true);
    xhttp.onreadystatechange = function () {
        if (this.readyState == 4 && this.status == 200) {
            // Response
            var response = this.responseText;
        }
    };
    var formData = new FormData();

    formData.append('crsf_token', t.parentElement.children[0].value);
    formData.append("text", t.parentElement.children[1].children[1].textContent);
    if (t.parentElement.children[4]) {
        formData.append('tkach', t.parentElement.children[3].value);
    }
    xhttp.send(formData);
}

function strip_tags(original) { //stackoveflowf
    return original.replace(/(<([^>]+)>)/gi, "");
}
let qrq = null;
function genQR() {
    const textel = document.querySelector('.editor');
    const text = textel.textContent;
    let qr = document.getElementById("qr");
    if (qrq) {
        qrq.clear();
        qr = document.createElement('div');
        qr.setAttribute('id', 'qr');
        document.body.appendChild(qr);
    }

    qrq = new Qreleak(qr, text);
    console.log('something wrong');
    const canvas = qrq;


    const timer = setTimeout(() => {
        const repsonser = document.getElementById('qr-link');
        if (repsonser) {
            repsonser.value = qr.children[1].src;
        }
    }, 1000);
}

function remove_all_childs(elem) {
    while (elem.firstChild) {
        elem.removeChild(elem.lastChild);
    }
}

function copyQR(e) {
    let test = document.getElementById('qr-link');
    navigator.permissions.query({ name: "clipboard-write" }).then((result) => {
        if (result.state === "granted" || result.state === "prompt") {
            /* write to the clipboard now */
            updateClipboard(test.value);
        }
    });
}

function updateClipboard(newClip) {
    navigator.clipboard.writeText(newClip).then(
        () => {
            console.log('test');
        },
        () => {
        },
    );
}
function save_doc(e) {
    const editor = window.editor.currentEditor;
    const time = Helper.get_time();
    if (editor) {
        if (editor.getAttribute('class') === 'editor') {
            if (window.store) {
                window.store.saveDoc(time, strip_tags(editor.innerHTML));
            }
        }
        else {
            if (window.store) {
                window.store.saveDoc(time, strip_tags(editor.textContent));
            }
        }
    }
}

function makeLinksForPicsInEditor() {
    let links = document.querySelectorAll('#pic_select');
    let editor = getEditorElement();
    if (links && editor) {
        for (let link of links) {
            link.addEventListener("click", (event) => {
                event.stopImmediatePropagation();
                event.preventDefault();
                const url = link.getAttribute('data-src');
                editor.value += '<img src="' + url + '">';
                editor_update();
            });
        }
    }
}

function changeTag(el, newTag) {
    let editor = document.createElement('textarea');
    editor.setAttribute('value', el.innerHTML);
    const id = el.getAttribute('data-id');
    editor.setAttribute('id', 'editor-box-' + id);
    editor.innerHTML = el.innerHTML;
    const form_id = 'form-edit-' + id;
    el.setAttribute('form', form_id);
    editor.setAttribute('form', form_id);
    el.parentNode.replaceChild(editor, el);
    return editor;
}

function handleDragStart(e) {
    this.style.opacity = '0.4';
    dragSrcEl = this;
    e.dataTransfer.effectAllowed = 'move';
    e.dataTransfer.setData('elem-id', e.target.getAttribute('data-id'));
    e.dataTransfer.setData('id', e.target.innerHTML);
}

function handleDragOver(e) {
    if (e.preventDefault) {
        e.preventDefault();
    }
    return false;
}

function handleDragEnter(e) {
    this.classList.add('over');
}

function handleDragLeave(e) {
    this.classList.remove('over');
}

function handleDragEnd(e) {
    this.style.opacity = '1';
    return false;
}

function handleDrop(e) {
    e.stopPropagation();
    if (dragSrcEl.getAttribute('id') === 'drag-elem') {
        dragSrcEl.innerHTML = '';
        var elementId = e.dataTransfer.getData("id");
        let elemId = e.dataTransfer.getData('elem-id');
        let items = document.getElementsByClassName("card");

        let resultElem = null;
        this.innerHTML += elemId + ',';
        this.style.width = "33%";
        this.style.height = "100%";
        for (let item of items) {
            if (item.getAttribute('data-id') === elemId) {
            }
        }
    }
    return false;
}
function makeDraggableCrads() {
    let items = document.querySelectorAll('#drag-elem');
    items.forEach(function (item) {
        item.setAttribute("draggable", true);
        item.addEventListener('dragstart', handleDragStart);
        item.addEventListener('dragover', handleDragOver);
    });
    let dropZone = document.getElementById("drop-zone");
    if (dropZone) {
        dropZone.addEventListener('dragover', handleDragOver);
        dropZone.addEventListener('dragenter', handleDragEnter);
        dropZone.addEventListener('dragleave', handleDragLeave);
        dropZone.addEventListener('dragend', handleDragEnd);
        dropZone.addEventListener('drop', handleDrop);
    }
}

function getTitle() {
    var test = document.getElementById('title');
    return test.getAttribute('data');
}

function spoilerClick(event) {
    var spoilers = GetAllElementsWithId('spoiler');
    if (event.srcElement.id === 'spoiler_click' && spoilers.length > 0) {
        var data = GetElementData(event.srcElement);
        if (data) {
            var spoiler = CheckIsSpoilerId(data);
        }
    }
}

function GetElementData(elem) {
    return elem.getAttribute('data-id');
}

function CheckIsSpoilerId(id) {
    var spoilers = GetAllElementsWithId('spoiler');
    if (spoilers.length > 0) {
        spoilers.forEach((spoiler) => {
            var data = GetElementData(spoiler);
            if (data == id) {
                if (spoiler.style.display === "none" || !spoiler.style.display)
                    spoiler.style.display = "block";
                else
                    spoiler.style.display = "none";
            }
        })
    }

}
function GetAllElementsWithId(id) {
    var arr = [];
    document.querySelectorAll('[id=' + id + ']').forEach(element => {
        arr.push(element);
    }
    );
    return arr;
}

function reg_user(e) {
    const crsf = e.parentElement.children[0] || null;
    const user = e.parentElement.children[1] || null;
    const pass = e.parentElement.children[2] || null;
    var formData = new FormData();
    formData.append("crsf_token", crsf.value);
    if (!user || !pass) {
        formData.append('logout', true);
    }
    else {
        formData.append("user", user.value);
        formData.append("password", pass.value);
    }
    var xhttp = new XMLHttpRequest();
    xhttp.open("POST", "/подполье", true);
    xhttp.onreadystatechange = function () {
        if (this.readyState == 4 && this.status == 200) {
            console.log(this.response);
            var response = parseInt(this.response);
            if (response) {
                switch (response) {
                    case Enums.COMPLETE_LOGOUT:
                    case Enums.SUCCESS_LOGIN:
                        {
                            window.location.replace('/');
                        }
                        break;
                }
            }
        }
    };
    xhttp.send(formData);
}
function spoilerClick(event) {
    var spoilers = GetAllElementsWithId('spoiler');
    if (event.srcElement.id === 'spoiler_click' && spoilers.length > 0) {
        var data = GetElementData(event.srcElement);
        if (data) {
            var spoiler = CheckIsSpoilerId(data);
        }
    }
}

function GetElementData(elem) {
    return elem.getAttribute('data-id');
}

function CheckIsSpoilerId(id) {
    var spoilers = GetAllElementsWithId('spoiler');
    if (spoilers.length > 0) {
        spoilers.forEach((spoiler) => {
            var data = GetElementData(spoiler);
            if (data == id) {
                if (spoiler.style.display === "none" || !spoiler.style.display)
                    spoiler.style.display = "block";
                else
                    spoiler.style.display = "none";
            }
        })
    }

}

function select_button(e) {
    console.log(e.target.value);
}

function GetAllElementsWithId(id) {
    var arr = [];
    document.querySelectorAll('[id=' + id + ']').forEach(element => {
        arr.push(element);
    }
    );
    return arr;
}