/*
this code under free to learn and exploration use,
there is covered GNU/GPL3 (as part of j4l no-care restrictions, just idea), with j4l restrictions:
you can modify, but not redist as anything, what that is not cost.
be ready for carmic destruction.
there is no way to cover obfusc on it - there is big question of life, universe and something other etc.
you can use it on production, with all over you modifications, you can install it for any non-commercial structures,
or with mailing to lostbyte32@gmail.com, with words: 'we want it', and take any representable answer for "why".
code is free to use, learn and research.

code redistutable as it and nobody care, for free exactly? with free to use, but with original link or hand-to-hand redistribution.
j4l 0.0.4 Common Annual Part Restrictions And No Cares Waranty Happens, self-licensed and as it 04.11.2023
// thanx stackoverflow - reddragonwebdesign, Roko C. Buljan

*/

class Editor {
    static form = '<div id="lb_visual_editor" style="display:block"><div class="toolbar"><button id="boldButton" title="Жирный"><b>Ж</b></button><button id="italicButton" title="Курсив"><i>К</i></button><button id="underlineButton" title="Подчёркнутый"><u>П</u></button><button title="Зачёркнутый" id="sup"><s>З</s></button><button title="Верхний индекс" id="ind-up">Верхний индекс</button><button title="Нижний индекс" id="ind-down">Нижний индекс</button><button title="Маркированный список" id="ul">Маркированный список</button><button title="Нумерованный список" id="ol">Нумерованный список</button><button title="Параграф" id="par">p</button><button title="Заголовок" id="head">H1</button><button title="Горизонтальная линия" id="hr">hr</button><button title="Цитата" id="qoute">Цитата</button><button title="Изображение" id="p-image">Изображение</button><button title="Ссылка" id="p-link">Ссылка</button><button title="Удаление ссылки" id="d-link">Удаление ссылки</button><button title="Вставить html" id="p-html">HTML</button>        <button title="Вставить текст" id="p-text">Text</button><br><button title="по левому краю" id="j-left">По левому</button><button title="по центру" id="j-center">По центру</button><button title="по правому краю" id="j-right">По правому</button><button title="по ширине" id="j-width">По ширине</button><select class="toolbar-font" id="f-style"><option selected="selected" disabled="disabled">Шрифт</option><option value="arial">Arial</option><option value="Courier New">Courier New</option><option value="georgia">Georgia</option><option value="impact">Impact</option><option value="roboto">Tahoma</option><option value="Times New Roman">Times New Roman</option><option value="verdana">Verdana</option></select><select class="toolbar-size" id="f-size"><option selected="selected" disabled="disabled">Размер</option><option value="1">10px</option><option value="2">12px</option><option value="3">14px</option><option value="4">16px</option><option value="5">18px</option><option value="6">21px</option><option value="7">26px</option></select><span>Цвет</span> <input class="toolbar-color" type="color" value="#ff0000" id="f-color"><span>Фон</span> <input class="toolbar-bg" type="color" value="#ffff00" id="b-color"><br><button id="undoButton" title="Отмена" id="undo">Отмена</button><button id="redoButton" title="Повтор" id="redo">Повтор</button><button title="Удалить" id="del">Удалить</button><button id="s-all">Выделить всё</button><button id="c-all">Очистить стили</button><button title="Вырезать" id="cut">Вырезать</button><button title="Копировать" id="copy">Копировать</button></div><div class="editor" id="editor" contenteditable="true"> </div></div>';
    static text = null;
    static changePanel = '<fieldset> <input type="radio" id="code_editor_button" name="code" value="code"  /><label for="code_editor_button">Редактор кода</label><input type="radio" id="visual_editor_button" checked name="code" value="visual"  /><label for="visual_editor_button">Визуальный редактор</label></fieldset>';
    static keywords = [
        "true"
        , "false"
        , "return"
        , "if"
        , "else"
        , "switch"
        , "case"
        , "break"
        , "continue"
        , "while"
        , "for"
        , "void"
        , "long"
        , "double"
        , "do "
        , "function"
        , '&lt;br&gt;'
    ];
    static lang = {
        js: {

            equa: /(\b=\b)/g,

            quot: /((&#39;.*?&#39;)|(&#34;.*?&#34;)|(".*?(?<!\\)")|('.*?(?<!\\)')|`)/g,
            comm: /((\/\*([^*]|[\r\n]|(\*+([^*/]|[\r\n])))*\*+\/)|(\/\/.*))/g,
            tags: /(?<=&lt;(?:\/)?)(\w+)(?=\s|\&gt;)/g,

            logi: /(%=|%|\-|\+|\*|&amp;{1,2}|\|{1,2}|&lt;=|&gt;=|&lt;|&gt;|!={1,2}|={2,3})/g,

            func: /(?<=^|\s*)(async|await|console|alert|Math|Object|Array|String|class(?!\s*\=)|function|for)(?=\b)/g,

            decl: /(?<=^|\s*)(var|let|const)/g,
            angl: /(&lt;\/?|&gt;)/g,
            attr: /((?<=<i class=html_tags>\w+<\/i>)[^<]+)/g,
            pare: /(\(|\))/g,

            squa: /(\[|\])/g,

            curl: /(\{|\})/g,

        },
        html: {
            tags: /(?<=&lt;(?:\/)?)(\w+)(?=\s|\&gt;)/g,
            angl: /(&lt;\/?|&gt;)/g,
            attr: /((?<=<i class=html_tags>\w+<\/i>)[^<]+)/g,
        },
        php: {
            equa: /(\b=\b)/g,
            quot: /((&#39;.*?&#39;)|(&#34;.*?&#34;)|(".*?(?<!\\)")|('.*?(?<!\\)')|`)/g,
            comm: /((\/\*([^*]|[\r\n]|(\*+([^*/]|[\r\n])))*\*+\/)|(\/\/.*))/g,
            logi: /(%=|%|\-|\+|\*|&amp;{1,2}|\|{1,2}|&lt;=|&gt;=|&lt;|&gt;|!={1,2}|={2,3})/g,
            numb: /(\d+(\.\d+)?(e\d+)?)/g,
            func: /(?<=^|\s*)(async|await|console|alert|Math|Object|Array|String|class(?!\s*\=)|function|for)(?=\b)/g,
            decl: /(?<=^|\s*)(var|let|const)/g,
            pare: /(\(|\))/g,
            squa: /(\[|\])/g,
            curl: /(\{|\})/g,

        }
    };
    constructor(form) {


        //this.convertFormToEditor();

        this.oldForm = form.cloneNode(true);
        this.element = form.parentElement;
        form.remove();
        this.startEditor();
        this.history = {
            back: [],
            forward: []
        };
        /*
        const editors = document.querySelectorAll(".highLite_editable");
        const lbedit = this;
        this.currentEditor = null;
        for (let el of editors) {
            el.contentEditable = true;
            el.spellcheck = false;
            el.autocorrect = "off";
            el.autocapitalize = "off";
            lbedit.currentEditor = el;
            el.addEventListener("input", () => lbedit.highLite(el));
            lbedit.highLite(el); // Init!
        }
      
        */
    }

    startEditor() {
        this.createPanel();
        const div = document.createElement('div');


        div.innerHTML = Editor.form;
        this.element.appendChild(div);
        let elems = this.oldForm.children;
        if (elems) {
            const editor_ = document.querySelector('.editor');
            for (let elem of elems) {
                const type = elem.type;
                console.log(type);
                if (type === 'textarea') {
                    editor_.innerHTML = elem.textContent;
                }
                //div.appendChild(elem);
                //elem.remove();
            };
            for (let elem of elems) {
                const type = elem.type;
                console.log(type);
                if (type === 'textarea') {
                    continue;
                }
                div.appendChild(elem);
                //elem.remove();
            };

        }

        this.element.appendChild(div);
        const editor = document.getElementById('editor');
        const fcolor = document.getElementById('f-color');
        const pimage = document.getElementById('p-image');
        const bcolor = document.getElementById('b-color');
        const boldButton = document.getElementById('boldButton');
        const italicButton = document.getElementById('italicButton');
        const underlineButton = document.getElementById('underlineButton');
        const undoButton = document.getElementById('undoButton');
        const redoButton = document.getElementById('redoButton');
        const plink = document.getElementById('p-link');
        const dlink = document.getElementById('d-link');
        const jleft = document.getElementById('j-left');
        const jright = document.getElementById('j-right');
        const jcenter = document.getElementById('j-center');
        const jwidth = document.getElementById('j-width');
        const fsize = document.getElementById('f-size');
        const fstyle = document.getElementById('f-style');
        const head = document.getElementById('head');
        const par = document.getElementById('par');
        const phtml = document.getElementById('p-html');
        const ptext = document.getElementById('p-text');
        const qoute = document.getElementById('qoute');
        const sup = document.getElementById('sup');
        const indup = document.getElementById('ind-up');
        const inddown = document.getElementById('ind-down');
        const ol = document.getElementById('ol');
        const ul = document.getElementById('ul');
        const del = document.getElementById('del');
        const sall = document.getElementById('s-all');
        const call = document.getElementById('c-all');
        const hr = document.getElementById('hr');
        const cut = document.getElementById('cut');
        const copy = document.getElementById('copy');
        if (!editor || !fcolor || !pimage || !bcolor || !boldButton || !italicButton || !underlineButton || !undoButton || !redoButton || !plink || !dlink || !jleft || !jright || !jcenter || !jwidth || !fsize || !fstyle || !head || !par || !phtml || !ptext || !qoute || !sup || !indup || !inddown || !ol || !ul || !del || !sall || !call || !cut || !copy || !hr) {
            console.log('there');
            return;
        }

        let lbedit = this;
        head.addEventListener('click', function () {
            performAction('formatBlock', false, 'h1');
        });
        hr.addEventListener('click', function () {
            performAction('insertHorizontalRule', false, null);
        });
        par.addEventListener('click', function () {
            performAction('formatBlock', false, 'p');
        });
        phtml.addEventListener('click', function () {
            var html = prompt('Введите HTML код', '');
            performAction('insertHTML', false, html);
        });
        ptext.addEventListener('click', function () {
            var text = prompt('Введите текст', '');
            performAction('insertText', false, text);
        });
        qoute.addEventListener('click', function () {
            performAction('formatBlock', false, 'blockquote');
        });
        sup.addEventListener('click', function () {
            performAction('bold');
        });
        indup.addEventListener('click', function () {
            performAction('superscript', false, null);
        });
        inddown.addEventListener('click', function () {
            performAction('subscript', false, null);
        });
        ul.addEventListener('click', function () {
            performAction('insertUnorderedList', false, null);

        });
        del.addEventListener('click', function () {
            performAction('delete', false, null);
        });
        ol.addEventListener('click', function () {
            performAction('insertOrderedList', false, null);
        });
        sall.addEventListener('click', function () {
            performAction('selectAll', false, null);
        });
        call.addEventListener('click', function () {
            performAction('formatBlock', false, 'div')
        });
        cut.addEventListener('click', function () {
            performAction('cut', false, null);
        });
        copy.addEventListener('click', function () {
            performAction('copy', false, null);
        });
        boldButton.addEventListener('click', function () {
            performAction('bold');
        });

        italicButton.addEventListener('click', function () {
            performAction('italic');
        });

        underlineButton.addEventListener('click', function () {
            performAction('underline');
        });

        undoButton.addEventListener('click', function () {
            if (!lbedit.history.back.length) {
                return;
            }
            lbedit.history.forward.push(editor.innerHTML);
            editor.innerHTML = lbedit.history.back.pop();
            editor.focus();
        });

        redoButton.addEventListener('click', function () {
            if (!lbedit.history.forward.length) {
                return;
            } lbedit.history.back.push(editor.innerHTML);
            editor.innerHTML = lbedit.history.forward.pop();
            editor.focus();
        });

        editor.addEventListener('keydown', function () {
            lbedit.history.forward.length = [];
            lbedit.history.back.push(editor.innerHTML);
        });
        fcolor.addEventListener('click', function () {
            let val = this.value;
            performAction('styleWithCSS', false, true);
            performAction('foreColor', false, val);
            performAction('styleWithCSS', false, false);
        });
        bcolor.addEventListener('click', function () {
            let val = this.value;
            performAction('styleWithCSS', false, true);
            performAction('hiliteColor', false, val);
            performAction('styleWithCSS', false, false);
        });
        pimage.addEventListener('click', function () {
            var url = prompt('Введите адрес изображения', '');
            performAction('insertImage', false, url);
            return false;
        });
        plink.addEventListener('click', function () {
            var url = prompt('Введите URL', '');
            performAction('CreateLink', false, url);
            return false;
        });
        fstyle.addEventListener('input', function () {
            var val = this.value;
            performAction('styleWithCSS', false, true);
            performAction('fontName', false, val);
            performAction('styleWithCSS', false, false);
        });
        fsize.addEventListener('input', function () {
            var val = this.value;
            performAction('styleWithCSS', false, true);
            performAction('fontSize', false, val);
            performAction('styleWithCSS', false, false);
        });
        dlink.addEventListener('click', function () {
            performAction('unlink', false, null);
            return false;
        });
        jleft.addEventListener('click', function () {
            performAction('justifyLeft', false, null);
            return false;
        });
        jright.addEventListener('click', function () {
            performAction('justifyRight', false, null);
            return false;
        });
        jcenter.addEventListener('click', function () {
            performAction('justifyCenter', false, null);
            return false;
        });
        jwidth.addEventListener('click', function () {
            performAction('justifyFull', false, null);
            return false;
        });
        function performAction(command) {
            if (!lbedit.history.back.length || lbedit.history.back[lbedit.history.back.length - 1] != editor.innerHTML) {
                lbedit.history.back.push(editor.innerHTML);
            }
            document.execCommand(command, false, null);
            editor.focus();
        }
        //there we must load that to editor?

    }

    createPanel() {
        if (this.element) {
            const panel = document.createElement('div');
            panel.setAttribute('id', 'change_editor');
            panel.innerHTML = Editor.changePanel;
            this.element.appendChild(panel);
        }
        const code = document.getElementById('code_editor_button');
        const visual = document.getElementById('visual_editor_button');

        code.addEventListener('click', () => {
            const editor = document.querySelector('.editor');
            if (!editor)
                return;
            editor.innerText = editor.innerHTML;
            editor.setAttribute('contenteditable', 'false');

        });
        visual.addEventListener('click', () => {
            const editor = document.querySelector('.editor');
            if (!editor)
                return;
            editor.setAttribute('contenteditable', 'true');
            editor.innerHTML = editor.textContent;

        });
        //console.log(code, visual);
    }
    static escapeHtml(text) {
        var map = {
            '&': '&amp;',
            '<': '&lt;',
            '>': '&gt;',
            '"': '&quot;',
            "'": '&#039;'
        };

        return text.replace(/[&<>"']/g, function (m) { return map[m]; });
    }
    static unescapeHtml(text) {
        var map = {
            '&amp;': '&',
            '&lt;': '<',
            '&gt;': '>',
            '&quot;': '"',
            "&#039;": "'"
        };

        return text.replace(/[&<>"']/g, function (m) { return map[m]; });
    }

    highLite(el) {
        const dataLang = el.dataset.lang;
        const langObj = Editor.lang[dataLang];
        let html = el.innerHTML;
        Object.keys(langObj).forEach(function (key) {
            html = html.replace(langObj[key], `<i class=${dataLang}_${key}>$1</i>`);
        });
        el.previousElementSibling.innerHTML = html;
    };

    addBoldTag() {
        const editor = getEditorElement();
        if (window.getSelection().toString().length) {
            let exactText = window.getSelection().toString();
            let inner = editor.value;
            const needle = inner.replace(exactText, '<b>' + exactText + '</b>');
            editor.value = needle;
            editor_update();
        }
    }

    addImgTag() {
        const editor = getEditorElement();
        if (window.getSelection().toString().length) {
            let exactText = window.getSelection().toString();
            let inner = editor.value;
            const needle = inner.replace(exactText, '<img src="' + exactText + '">');
            editor.value = needle;
            editor_update();
        }
    }

    addItalicTag() {
        const editor = getEditorElement();
        if (window.getSelection().toString().length) {
            let exactText = window.getSelection().toString();
            let inner = editor.value;
            const needle = inner.replace(exactText, '<i>' + exactText + '</i>');
            editor.value = needle;
            editor_update();
        }
    }
    checkEditorSelection() {
        const editor = getEditorElement();
        if (!editor)
            return;
        editor.addEventListener('mouseup', event => {
            if (window.getSelection().toString().length) {
                let exactText = window.getSelection().toString();
            }
        });
    }
}