<?php

/*
 * this code under free to learn and exploration use,
 * there is covered GNU/GPL3, with j4l restrictions:
 * you can modify, but not redist as anything, what that is not cost.
 * be ready for carmic destruction.
 * there is no way to cover obfusc on it - there is big question of life, universe and something other etc.
 * you can use it on production, with all over you modifications, you can install it for any non-commercial structures,
 * or with mailing to lostbyte32@gmail.com, with words: 'we want it', and take any representable answer for "why".
 * code is free to use, learn and research.
 *
 * code redistutable as it and nobody care, for free exactly? with free to use, but with original link or hand-to-hand redistribution.
 * j4l 0.0.4 Common Annual Part Restrictions And No Cares Waranty Happens, self-licensed and as it 12.12.2023
 */

namespace Controllers;

use App\Application;
use App\Focker;
use App\RewriteRulesParser;
use Cache\SimpleCache;
use Files\FileWorker;
use Foundation\Constructor;
use Helper\Enums;
use Helper\SystemHelper;
use Helper\TimeHelper;
use Helper\WebHelper;
use Logger\LogDebug;
use Models\BasicUser;
use Models\News;
use Models\User;
use Modules\Balto\Common\Signals;
use Modules\Balto\Balto;
use Modules\Helpfull\Telegram;
use Modules\Pregol\Pregol;
use Modules\Qluiza\Qluiza;
use Modules\Qrilo\Qrilo;
use Modules\Tkach\Tkach;
use Security\BasicSecurity;
use Widgets\FormBuilder;
use Models as models;
use Widgets\NavbarBuilder;

// at that moment we must to make form builder, for next work with it?
// is there is biggest dial? i don't think so, but it's now look bad.
// yii2 perform to create model, with labels, checks and additions
// we must to simplyfy creating form, like as form_builder present
// and... don't have any idea at now.

// for example we must create form for editing content
// there is get news from database, and make form for that?

class MainController
{
    public $app;
    private array $_meta_data;
    private string $_meta = '';
    private string $_title = '';
    private string $_layout_header, $_layout_footer, $crsf;
    function __construct(Application $app)
    {
        $this->app = $app;
        $this->_layout_header = "header";
        $this->_layout_footer = "footer";
        $this->crsf = $this->registerCrsf();
        $this->_title = $app->name;
    }

    public function setTitle($title)
    {
        $this->_title = $title;
    }
    protected function registerMetaTag($tagName, $content)
    {
        $this->_meta .= $this->register_metas($tagName, $content) . PHP_EOL;
    }
    protected function registerCrsf()
    {
        $crsf = BasicSecurity::getCrsfToken();
        return $crsf;
    }
    public function prepare_header($layout, $meta_name, $content)
    {
        $data = $this->register_metas($meta_name, $content);
    }
    protected function render($view, $data = [])
    {
        ob_start();
        //header("'Service-Worker-Allow' : '/'");
        extract($data);
        $footer_data = ['::app_name' => Focker::$app->name, "::scripts" => $this->app->assetMgr->get_metas_scripts()];
        $bread_stuff = Focker::$app->name . ' :: ' . Focker::$app->description;
        $first_order_scripts = [$this->app->assets_dir . 'scripts/qrеlak/Qrеlak.js', $this->app->assets_dir . 'scripts/lbanimator/helper.js', $this->app->assets_dir . 'scripts/lbedit/Components/lbcache/Storage.js', $this->app->assets_dir . 'scripts/lbedit/Common/enums.js', $this->app->assets_dir . 'scripts/lbedit/Common/app.js', $this->app->assets_dir . 'scripts/lbedit/Components/Editor.js',];
        $header_data = ['::app_name' => Focker::$app->name, '::title' => $this->_title, '::meta' => $this->_meta, '::crsf_key' => $this->crsf, '::bread_stuff' => $bread_stuff, '::navbar' => $this->generate_navbar(), '::scripts' => $this->app->assetMgr->registerJsFiles($first_order_scripts), '::styles' => $this->app->assetMgr->get_styles()];
        $this->generateLayout($this->_layout_header, $header_data);
        include_once "views/$view.php";
        $this->generateLayout($this->_layout_footer, $footer_data);
        ob_end_flush();
    }
    public function generate_navbar()
    {
        $login_adm = BasicSecurity::get_user_login_status() ? $login_adm = ['/админ' => 'Админ-панель'] : [];
        $login = BasicSecurity::get_user_login_status() ? $login = ['/подполье' => 'Выйти'] : $login = ['/подполье' => 'Зайти с паролем'];
        $navbar_elems = ['/' => 'Главная', '/заценить/30' => 'Ответственность', '/editnews/2' => 'Редактор', '/курило' => '(<b>Q</b>u<b>R</b>ilo/КуРElag) генератор', '/преголь' => 'Преголь', '/периметр' => 'Периметр!', '/гостевая' => 'Отзывы', '/админ' => 'Админкка', '/заценить/8' => 'Состав системы', '/focкtrix.zip' => 'Скачать решение'];
        if (is_array($login)) {
            $navbar_elems = array_merge($navbar_elems, $login_adm, $login);
        }
        $navbar = new NavbarBuilder();
        return $navbar->make_navbar($navbar_elems);
    }
    private function register_metas(string $name, $data)
    {
        $content = '';
        $meta_tag = '<meta name="%s" content="%s">';
        if (is_array($data)) {
            if (!empty($data)) {

                foreach ($data as $k => $value) {
                    if ($k >= count($data) - 1) {
                        $content .= $value;
                    } else
                        $content .= $value . ', ';
                }
            }
        } else {
            $content = $data;
        }
        $data = sprintf($meta_tag, $name, $content);
        return $data;
    }
    public function doAction($action)
    {

        $className = 'Controllers\MainController';
        if (empty($action)) {
            //return $this->actionError(0);  // there is weird, check it latter
        }
        if (empty($action['rule'])) {
            $this->actionError(404);
            return;
        }
        $funcName = null;
        $call = null;
        list($funcName, $call) = RewriteRulesParser::get_pretty_action($action['rule']);
        $page_param = [];
        $page_query = null;
        $page = null;
        if (!empty($action['arg']) && $call != end($action['arg'])) {
            $page = end($action['arg']);
            $page_param['num'] = $page;
            if (count($action['arg']) > 0) {
                $page_query = $action['arg'];  // that is litle bit shitty, as fock!
            }
        }
        $page_param['query'] = $page_query;  // there is CRITICAL FOR TRIXXX, and there is can be reused for non-code building
        if (!$this->app->is_installed && $funcName != 'actionCached') {
            $funcName = 'actionInstall';
        }
        call_user_func_array(array($className, $funcName), [$page_param]);
        //var_dump($result);
    }

    public function actionView($page)
    {
        if (empty($page['num']))
            $page['num'] = 1;

        $data = null;
        $feautered = null;
        if ($this->app->system_cache)
            $data = $this->app->system_cache->getFromCache(__FUNCTION__, $page['num']);
        if (empty($data)) {
            $news = new News();
            $some['pagination'] = null;
            $data = $news->GetById($page['num']);
            if (!$data) {
                $this->actionError(404);
                die();
            }
            $data->date = SystemHelper::convertToRussianTimeFromUts($data->date);
            $content[] = (object) ['guid' => -100, 'public_id' => 'null', 'parsed_id' => null, 'post_title' => $data->title, 'content' => $data->content, 'date' => $data->date, 'author' => $data->author, 'short_desc' => $data->short_desc];
            $data = $some;
            $data['data'] = $content;
            $content = SimpleCache::serialize_data($data['data'], null, null);
            if ($this->app->system_cache)
                $this->app->system_cache->saveToCache(__FUNCTION__, $page['num'], $content);
        } else {
            $data = SimpleCache::restore_data($data);
        }
        $this->render('single', ['arcticle' => $data['data'][0]]);
    }

    public function actionCached()
    {
        header("Content-type: application/x-javascript");

        $look_over = "var urlsToCache =['/',";
        $look_over .= '];';
        $site = $this->app->name;
        $js = <<<JS
            var CACHE_NAME = "%s";
        self.addEventListener('activate', function (event) { var cacheWhitelist = ['%s']; event.waitUntil( caches.keys().then(function (cacheNames) { return Promise.all( cacheNames.map(function (cacheName) { if (cacheWhitelist.indexOf(cacheName) === -1) { return caches.delete(cacheName); } }) ); }) ); });
        self.addEventListener('fetch', function(event) {event.respondWith( fetch(event.request).catch(() => caches.match(event.request))); });
        self.addEventListener( "message", event => {e});
        JS;
        print_r($look_over . sprintf($js, $site, $site));
    }

    public function actionZip()
    {
        $files = FileWorker::read_full_dir($this->app->base_dir . '/abyss/');
        FileWorker::create_gzip($files);
    }

    public function actionCreator()
    {
        $controller = $this->app->base_dir . '/framework/components/Controllers/MainController.php';
        $functions = Constructor::get_functions($controller);
        var_dump($functions['functions']);
        /*
        $find_regular_functions = '/function\s+(?<name>\w+)\s*\((?<param>[^\)]*)\)\s*(?<body>\{(?:[^{}]+|(?&body))*\})/';
        $function_name_finder = '/function[\s\n]+(\S+)[\s\n]*\(/';
        $functions_names = [];
        $functions = array();
        preg_match_all($find_regular_functions, $controller, $functions);
        require($this->app->url_rewrite_rules_file);
        preg_match_all($function_name_finder, $controller, $functions_names);
        if (count($functions_names) > 1) {
            foreach ($functions_names[1] as $function) {
                foreach ($options as $rule => $action) {
                    if (RewriteRulesParser::get_pretty_action($action)[0] == $function) {
                        print_r($rule . ' : ' . $function . '<br>' . PHP_EOL);
                    }

                }
            }
        }
        */
        //there is must to get this->render
    }

    public function actionInstall($page = null)
    {
        if ($this->app->is_installed) {
            $this->render('error', ['error' => 333]);
            return;
        }
        $installer = $this->app->installer;
        if (!empty($page['num'])) {

            switch ($page['num']) {
                case 'rights_check': {
                    print_r($installer->check_rights_premissions_file(Focker::$app->base_dir));
                }
                    break;
                case 'host_check': {
                    if (!empty(Focker::$app->post)) {
                        $data = $installer::prepare_data(Focker::$app->post);

                        @Focker::$app->dbMgr->loadConfig($data);
                        if (!Focker::$app->dbMgr->connect())
                            print_r(Focker::$app->dbMgr->last_error);
                        else
                            print_r('connected!');
                    }
                }
                    break;
                case 'finish': {
                    $installer->installation();
                }
                    break;
            }
            return;
        }
        $form = new FormBuilder();
        $form->buildForm('install_form', 'form-style-grayfox');
        $form->createTextElem('site_url', '', 'Адресс сайта, например https://focktrix.hyperfeed.xyz');
        $form->createSelection('install_type', 'install_type', ['----' => 'Тип установки', 'Mysql' => 'MYSQL', 'static' => 'Статика'], 'install_type(event)');

        $form->createTextElem('admin_user', '', 'Администратор сайта');
        $form->createTextElem('admin_pass', '', 'Пароль администратора сайта');
        $form->createTextElem('admin_confirm', '', 'Повторить пароль администратора');
        $form->createTextElem('host', '', 'Адресс MYSQL сервера');
        $form->createTextElem('port', '', 'Порт MYSQL сервера');
        $form->createTextElem('user', '', 'Пользователь БД');
        $form->createTextElem('pass', '', 'Пароль пользователя БД');
        $form->createTextElem('database', '', 'Имя базы данных');
        $form->createTextElem('app_name', '', 'Название приложения');
        $form->createTextElem('app_desc', '', 'Описание приложения');
        $form->createTextElem('uploads_dir', 'uploads/', 'Папка для загрузки добра, по умолчанию /uploads/');
        $form->createTextElem('assets_dir', 'assets/', 'Папка с набором файлов приложения (скрипты, стили, картинки)');
        $form->createTextElem('crypt_key', '', 'SecretCode - luboe na translite ');
        $form->createTextElem('cache_store_type_update', '0', 'Как обновлять кэш (только 0)');
        $form->createTextElem('cache_store_update_timer', TimeHelper::ONE_MINUTE * 30, 'Когда обнолять кэш (при 0 выше');
        $form->createInput('checkbox', 'use_server_cache', 'true', 'Серверный кэш (SimpleCache)', true);
        $form->createInput('checkbox', 'use_client_cache', 'true', "Клиент кэш (SimpleCache)", true);
        $form->createButton('', 'Проверить и установить!', 'check_install(this)');
        $form->completeFormBuilder();
        $data = $form->getForm();
        $this->render('install', ['form' => $data]);
    }



    public function actionTelega()
    {
        $balto = new Balto($this->app->modules['balto']['api_key'], false);
        $qluiza = new Qluiza();
        $hooks = $balto->initWebhooks();
        // that's work? todo::allmost remove, when checked!
        if (!empty($hooks['file'])) {
            switch ($hooks['file']) {
                case Signals::FILE_EXIST: {

                    // TODO :: there is must be check for answers from user?
                    $welcome = $qluiza->greetings();
                    $question = $qluiza->getRandomQuestion();  // got random question
                    $messages = $qluiza->getAnswersForQuestionId($qluiza->getLastQuestionId());  // got that answers
                    $buttons = [];
                    foreach ($messages as $id => $quiz_question) {
                        $buttons[] = $balto->makeInlineButton($quiz_question, null, '/answ_' . $id . '/q_' . $qluiza->getLastQuestionId());  // prepare balto btns
                    }
                    $keyboard = $balto->makeKeyboard($buttons);  // give balto keyboard
                    // next part: hearing and sessioning... maybe yes maybe not...
                    $data = $balto->awaitTransictions($question);
                    $chat_id = $data['data']['message']['from']['id'];
                    $message_id = null;
                    if (!empty($data['callback_data'])) {
                        $answer = @$data['callback_data']['data'];
                        $message_id = $data['callback_data']['message']['message_id'];
                        $answer = explode('/', $answer);
                        $q = @$answer[2];
                        $a = @$answer[1];
                        $q = explode('_', $q)[1]; //question
                        $a = explode('_', $a)[1]; //user answer
                        $chat_id = @$data['callback_data']['message']['chat']['id'];
                        $result = $qluiza->checkAnswer((int) $q, (int) $a, $balto);
                        if ($result) {
                            $balto->greetings($chat_id, $message_id, $keyboard, "Верно! Следующий вопрос." . $question);

                        } else {
                            $balto->greetings($chat_id, $message_id, $keyboard, 'Неверно. Следующий вопрос.' . $question);
                        }
                    } else {

                        $balto->greetings($chat_id, $message_id, $keyboard, 'Итак вопрос! ' . $question);
                    }
                }
                    break;
            }
        }
        print_r($hooks);
    }

    public function actionTelegastop()
    {
        $balto = new Balto($this->app->modules['balto']['api_key'], false);
        print_r($balto->removeWebhooks());
    }

    public function actionTelegatest()
    {
        $balto = new Balto($this->app->modules['balto']['api_key'], false);
        print_r($balto->sendHello());
    }

    public function actionTest()
    {
        $this->render('edit');
        // return $this->render('test');
    }

    public function exerceptContent($rows)
    {
        if (is_array($rows)) {
            foreach ($rows as $row) {
                $row->content = WebHelper::excercept($row->content);
            }
        }
        return $rows;
    }

    public function actionQr($page)
    {
        if (empty($page['num'])) {
            $page['num'] = 'https://focktrix.hyperfeed.xyz';
        }
        if ($this->app->isPostRequest) {
            $page['num'] = $this->app->post['text'];
        }
        Qrilo::make_qr($page['num']);
    }

    public function actionQrgen()
    {
        $form = new FormBuilder();
        $form->buildForm('news_edit');
        $form->textarea('news_text', 'Введите текст для генерации QR кода');
        $form->createButton('GenQR', 'Генерировать QR', 'genQR(this)');
        $form->createButton('CopyQR', 'Копировать', 'copyQR(this)');
        $form->createTextElem('qr-link', 'ссылка на qr');
        $form->completeFormBuilder();
        $data = $form->getForm();
        $this->setTitle('Генератор QR кода для личных нужд');
        $this->registerMetaTag('description', 'Генерация QR кода бесплатно без смс отечественное русское по');
        $this->registerMetaTag('keywrords', ['фоктрикс', 'генератор qr', 'qr', 'создать qr', 'qr россия', 'куар код']);
        $this->render('qrgen', ['form' => $data]);
    }

    public function actionAnimator($page)
    {
        $this->render('animator', []);
    }

    public function actionCaptcha()
    {
        if (Focker::$app->isPostRequest) {
            var_dump(Focker::$app->post);
            return;
        }

        $this->app->tkachenko->generate_capcha();
    }

    public function actionGuestbook($page = null)
    {

        if (Focker::$app->isPostRequest) {

            $text = strip_tags(Focker::$app->post['text']);
            $ip = Focker::$app::get_ip();

            $capcha = Focker::$app->post['tkach'];
            if ($capcha) {
                if ($this->app->tkachenko->check_capcha($capcha)) {
                    $news = new models\News();
                    $data = $news->add_guest_post($ip, $text, time());
                }
            }
            //
            return null;
        }
        $data = null;
        if ($this->app->system_cache)
            $data = $this->app->system_cache->getFromCache(__FUNCTION__, $page['num']);
        $feautered = null;
        if (empty($data)) {
            $news = new models\News();
            $data = $news->getAll($page['num'], null, 4, 5);
            if (!$data['data']) {
                $this->actionError(404);
                die();
            }
            foreach ($data['data'] as $row) {
                // convert to russian, take it from runet
                $row->date = SystemHelper::convertToRussianTimeFromUts($row->date);
            }
            if ($page && $page['num'] < 1)
                $feautered = $news->getLastFeaturedPost();
            $content = SimpleCache::serialize_data($data['data'], $data['pagination'], $feautered);
            if ($this->app->system_cache)
                $this->app->system_cache->saveToCache(__FUNCTION__, $page['num'], $content);
        } else {
            $data = SimpleCache::restore_data($data);
            $feautered = $data['add'];
        }
        // there is must be build for pagination
        // like you give it class, id, current_page, all pages
        $form = new FormBuilder();
        $form->buildForm('news_edit', 'form-style-grayfox', 'default', true, true);
        $form->textarea('news_text', 'текст для отправки');
        $form->createButton('MakePost', 'Оставить запись', 'post_guest(this)');

        $form->completeFormBuilder();
        $form = $form->getForm();
        $this->setTitle('Гостевая ФОКТРИКС - отзывы и предложения. Оставь след или нет!');
        $this->registerMetaTag('description', 'FocКtrix - оставь свой след, наступив на планку...');
        $this->registerMetaTag('keywrords', ['фоктрикс', 'программное обеспечение', 'фоктрикс планка', 'фоктрикс дно', 'фоктрикс топка', 'фреймворк']);
        $this->render('guestbook', ['articles' => $data['data'], 'fp' => $feautered, 'pagination' => $data['pagination'], 'form' => $form]);

    }

    public function actionEditnews($news_id = null)
    {
        if (empty($news_id['num'])) {
            // there must to render just adding;
            // set temp placeholder
            //return $this->actionError();
        }
        $news = new models\News();
        $data = $news->GetById($news_id['num']);
        // at here we must create form?
        $form = new FormBuilder();
        $form->buildForm('news_edit');
        $form->textarea('news_text', $data->content);
        $form->createButton('save_doc', 'Сохранить файл', 'save_doc(this)');
        $form->completeFormBuilder();
        $data = $form->getForm();
        $this->setTitle('Редактор кода с подсветкой синтаксиса');
        $this->render('testeditor', ['form' => $data]);
    }

    public function actionIndex($page)
    {
        $data = null;

        if (empty($page['num']))
            $page['num'] = 1;
        if ($this->app->system_cache)
            $data = $this->app->system_cache->getFromCache(__FUNCTION__, $page['num']);
        $feautered = null;
        // there is must be session cockie?
        // we must get user from cookie?
        //$user = BasicSecurity::get_user_login_status();
        if (empty($data)) {
            $news = new models\News();

            $data = $news->getAll($page['num'], null, null, 5);
            if (!$data['data']) {
                $this->actionError(404);
                die();
            }
            foreach ($data['data'] as $row) {
                // convert to russian, take it from runet
                $row->date = SystemHelper::convertToRussianTimeFromUts($row->date);
            }
            if ($page && $page['num'] < 1)
                $feautered = $news->getLastFeaturedPost();

            $content = SimpleCache::serialize_data($data['data'], $data['pagination'], $feautered);
            if ($this->app->system_cache)
                $this->app->system_cache->saveToCache(__FUNCTION__, $page['num'], $content);
        } else {
            $data = SimpleCache::restore_data($data);
            $feautered = $data['add'];
        }
        // there is must be build for pagination
        // like you give it class, id, current_page, all pages
        $this->registerMetaTag('description', 'FocКtrix - лучший поставщик ведёр и трюков, с 2024-го года.');
        $this->registerMetaTag('keywrords', ['фоктрикс', 'программное обеспечение', 'типа не биткс', 'отечественное', 'конструктор', 'фреймворк']);
        $this->render('index', ['articles' => $data['data'], 'fp' => $feautered, 'pagination' => $data['pagination']]);
    }

    public function actionError($error = 0)
    {
        if ($error == 404)
            header("HTTP/1.0 404 Not Found");
        $this->render('error', ['error' => $error]);
    }

    public function actionCrawler()
    {
        $url = 'https://divan.hyperfeed.xyz';
        $pregol = new Pregol($url);
        $pregol->r_branch->begin()->tag('div')->class('feautered-post')->drown()->all()->drown()->all();
        $link = SystemHelper::first_of_iter($pregol->build_query($pregol->r_branch->query));
        $href = $pregol->convert_to_url_href($pregol->l_branch::href($link));
        unset($pregol);
        $pregol = new Pregol($href);
        $pregol->r_branch->begin()->tag('div')->drown()->all();
        $data = SystemHelper::first_of_iter($pregol->build_query($pregol->r_branch->query));
        $title = $data->nodeValue;
        $pregol->r_branch->begin()->tag('div')->class('single-page');
        $data = SystemHelper::first_of_iter($pregol->build_query($pregol->r_branch->query));
        $text = $pregol->l_branch::HTML($data);
        $pregol->r_branch->begin()->tag('div')->drown()->all()->class('author');
        $data = SystemHelper::first_of_iter($pregol->build_query($pregol->r_branch->query));
        $author = $data->nodeValue;
        var_dump($title, $author, $text, );
        return [$title, $text, $author];


    }

    public function actionLogin()
    {
        if (Focker::$app->isPostRequest) {
            $user = !empty(Focker::$app->post['user']) ? Focker::$app->post['user'] : null;
            $pass = !empty(Focker::$app->post['password']) ? Focker::$app->post['password'] : null;
            if (!empty(Focker::$app->post['logout'])) {
                BasicSecurity::recall('user_id', true);
                die((string) Enums::COMPLETE_LOGOUT);
            }
            $user = $this->get_user($user, $pass);
            if ($user::isLogined())
                die((string) Enums::SUCCESS_LOGIN);
            else
                die((string) Enums::SUCCESS_LOGIN);
        }
        $form = new FormBuilder();
        if (BasicSecurity::recall('user_id')['session']) {
            $form->buildForm('login_form', 'form-style-grayfox');
            $form->createButton('logout', 'Выбраться', 'reg_user(this)');
            $form->completeFormBuilder();
            $form = $form->getForm();
        } else {

            $form->buildForm('login_form', 'form-style-grayfox');
            $form->createTextElem('user_login', 'Имя пользователя');
            $form->createPasswordElem('user_password', 'Пароль');
            $form->createButton('reg_user', 'Пробраться', 'reg_user(this)');
            $form->completeFormBuilder();
            $form = $form->getForm();

        }
        $this->render('login', ['form' => $form]);
    }


    public function get_user($username, $pass): ?User
    {
        $users = new BasicUser();
        $user = $users->getByName($username);
        $user = new User($user->name, $pass);
        //print_r($user::$username);
        return $user;
    }


    public function actionEditor($file_id = null)
    {
        $file_data = null;
        $form = new FormBuilder();
        $form->buildForm('news_edit');

        if ($file_id['num'] && $file_id['num'] != 55) {  // there is ugly hack to prevent look over config.php
            $file = FileWorker::get_file_in_dir_by_id(Focker::$app->base_dir, $file_id['num']);
            if ($file)
                $form->textarea('news_text', htmlentities($file));
        }
        $form->completeFormBuilder();
        $form = $form->getForm();
        $this->setTitle('Редактор кода с подсветкой синтаксиса');
        // $highlight = highlight_file('framework/classes/Config/DbMgr.php');
        $this->render('testeditor', ['form' => $form]);
    }
    public function actionUpload()
    {
        $user = BasicSecurity::recall('user_id')['session'];
        //
        if (Focker::$app->isPostRequest) {
            if (!empty(Focker::$app->files) && $user && BasicSecurity::get_user_login_status()) {

                $user = $this->get_user($user);

                if ($user && $user::is_admin())
                    die(FileWorker::save_upload_files());
            }
        }
        $form = new FormBuilder();
        $form->buildForm('upload', 'form-style-grayfox', 'default', true, 'POST', 'multipart/form-data');
        $form->createFileSave('pic[]', 'file to save', true);
        $form->createButton('save_file', 'Залить файл', 'upload_file(this)');
        $form = $form->getForm();
        $this->render('testeditor', ['form' => $form]);
    }

    public function actionAjaxhighlight()
    {
        if (Focker::$app->isPostRequest) {
            var_dump(Focker::$app->post);
        }
    }

    public function generateLayout($layout, $params = []): ?string
    {
        $layout = file_get_contents('layouts/' . $layout . '.html');
        $final_html = strtr($layout, $params);
        return print ($final_html);
    }

    public function actionApi()
    {
        $news = new News();
        if (Focker::$app->post && Focker::$app->post['page'])
            $page = Focker::$app->post['page'];
        else
            $page = 1;
        $data = $news->getLatestNewsOnPage($page);
        $data['client_cache'] = Focker::$app->client_cache;
        $api = json_encode($data);
        print_r($api);
    }

    public function actionAdmin()
    {
        if (BasicSecurity::recall('user_id')['session']) {
            $files = FileWorker::read_full_dir(Focker::$app->base_dir);
            // there is must be render, and must be part of code to work with it
            // cover it and have minds to AJAX;
            //there available with test and default password on login page
            return $this->render('admin', ['files' => $files]);
        }
        $this->actionError();

    }
}
