<?php
namespace Foundation;

use Files\FileWorker;

class Constructor
{
    //there is what is it?
    public static function get_functions($phpfile)
    {
        $phpfile = FileWorker::read_file_as_string($phpfile);
        $find_regular_functions = '/function\s+(?<name>\w+)\s*\((?<param>[^\)]*)\)\s*(?<body>\{(?:[^{}]+|(?&body))*\})/';
        $functions = array();
        preg_match_all($find_regular_functions, $phpfile, $functions);
        return ['functions' => $functions[0], 'names' => $functions[1]];
    }

    public static function get_functions_names($phpfile)
    {
        $phpfile = FileWorker::read_file_as_string($phpfile);
        $function_name_finder = '/function[\s\n]+(\S+)[\s\n]*\(/';
        $functions_names = [];
        preg_match_all($function_name_finder, $phpfile, $functions_names);
        return $functions_names[1];
    }
}