<?php
namespace Helper;

class StringHelper
{
    public static function lower_letters($string): ?string
    {
        return mb_strtolower($string);
    }

    public static function is_number($string): ?int
    {
        $result = null;
        if (is_numeric($string)) {
            $result = (int) preg_replace('/[^0-9]/', '', $string);
        }
        return $result;
    }

    public static function is_string($string): ?bool
    {
        $result = false;
        if (!is_numeric($string)) {
            $result = is_string($string);
        }
        return $result;
    }
    public static function get_beetwen(string $string): ?array
    {
        $matches_res = null;
        preg_match_all("/\[(.*?)\](.*?)\[(.*?)\]/", $string, $matches_res);
        return $matches_res[2];
    }

}