<?php
/*
Редакционная версия 1.
Версия лицензии 0.5.
Система модулей, в виду определённого качества и доступа - будь то парсеры, боты и прочее - 
используется для других целей - это может быть использовано в некомерческих организациях, однако уже обратно-золотно. Так как - модули - могут быть слегка не этичными. Модули свободного распространения - свободно распространяются среди коммерческих. Кроме модулей, явно предлагаемых, как продукт. Как продукт специально удовлетворяющий потребности некоммерческих организаций. Естественно - никаких регламентов не используется. Исключение - этика. Whenevere it cost, whatever it takes. 
Действующая лицензия j4l - предусматривает полное отсечение любой общей связи с GNU/GPL, в частности третьей редакции. То есть наследие, да. Остальное само собой разумеется.
Части программного обеспечения - так-же и остаются для свободного изучения, хобби,  чего угодно - что не противоречит. Главному. Здоровому интересу.
Распространяется по принципу "холодной разработки" - до момента, когда например - пример реализации хранилища версий. На решении.
Из рук-в-руки. Без третьих лиц наглых.
Код подлежит сертификации, контролю качеству и своеобразного патента код явный, авторский.
Лицензия j4l имеет алиас чпп.
j4l/ЧПП 0.5, Ежегодный внеочередной пересмотр условий лицензирования.

оригинальный код: https://github.com/kreativekorp/barcode
*/

namespace Modules\Qrilo;

use Helper\Enums;
use Modules\Modules;
use Modules\Qrilo\System\Renderer;


class Qrilo extends Modules
{
	public static $data;
	public static $options;
	const AUTHOR = "xorx";
	const MODULE_NAME = "Qrilo";
	const DESC = "модуль - генератор QR кода/штрихкода";
	const LICENSE = Enums::DISTRIBUTION_BOTH_FREE;
	function __construct($data = "Проверка", $options = [])
	{
		parent::__construct(Qrilo::AUTHOR, Qrilo::MODULE_NAME);
		$defaults = [
			's' => 'qrl'
		];

		if (!is_array($options))
			$options = [];

		$this->data = $data;
		$this->options = array_merge($defaults, $options);
	}

	public static function make_qr($data, $options = ['s' => 'qr-h', 'sf' => 8, 'ms' => 'r', 'md' => 1])
	{
		return Renderer::output_image($data, $options);

	}

}
