-- MySQL dump 10.19  Distrib 10.3.39-MariaDB, for debian-linux-gnu (x86_64)
--
-- Host: localhost    Database: focktrix
-- ------------------------------------------------------
-- Server version	10.3.39-MariaDB-0+deb10u1

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `category`
--

DROP TABLE IF EXISTS `category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `category` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  `desc` text DEFAULT NULL,
  `url` text DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `category`
--

LOCK TABLES `category` WRITE;
/*!40000 ALTER TABLE `category` DISABLE KEYS */;
/*!40000 ALTER TABLE `category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `city`
--

DROP TABLE IF EXISTS `city`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `city` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  `desc` text DEFAULT NULL,
  `locate` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `city`
--

LOCK TABLES `city` WRITE;
/*!40000 ALTER TABLE `city` DISABLE KEYS */;
/*!40000 ALTER TABLE `city` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `migration`
--

DROP TABLE IF EXISTS `migration`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `migration` (
  `version` varchar(180) NOT NULL,
  `apply_time` int(11) DEFAULT NULL,
  PRIMARY KEY (`version`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `migration`
--

LOCK TABLES `migration` WRITE;
/*!40000 ALTER TABLE `migration` DISABLE KEYS */;
/*!40000 ALTER TABLE `migration` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `news`
--

DROP TABLE IF EXISTS `news`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `news` (
  `guid` int(11) NOT NULL AUTO_INCREMENT,
  `public_id` bigint(20) DEFAULT NULL,
  `parsed_id` bigint(20) DEFAULT NULL,
  `title` varchar(255) DEFAULT NULL,
  `content` text DEFAULT NULL,
  `date` bigint(20) DEFAULT NULL,
  `type` int(11) DEFAULT NULL,
  `visible` tinyint(1) DEFAULT NULL,
  `author` varchar(255) DEFAULT NULL,
  `rubricator` varchar(255) DEFAULT NULL,
  `linked_news` text DEFAULT NULL,
  `news_picture` text DEFAULT NULL,
  `short_desc` varchar(255) DEFAULT NULL,
  `city_id` bigint(20) DEFAULT NULL,
  `category_list` text DEFAULT NULL,
  `ip_resolution` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`guid`)
) ENGINE=InnoDB AUTO_INCREMENT=15 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `news`
--

LOCK TABLES `news` WRITE;
/*!40000 ALTER TABLE `news` DISABLE KEYS */;
INSERT INTO `news` VALUES (1,NULL,NULL,'Искали Битрикс? Вы нашли не его...','<h3>Focktrix - решение проблемы, которой не было. И не будет</h3>\r\n<p>Предлагается использовать в качестве изучения и улучшения по принципу \"холодной\" разработки - для своих, в кругу своя.<br>\r\nПредполагается использование в некомерческих организациях без особых условий, не возбраняется использование в коммерческом секторе - но только по взаимовыгодному общению<br>\r\nРаботает, не работает - как есть. Спасибо. Пользуйтесь или нет - каждому своё. Спасибо за внимание!\r\n</p>',1698965757,0,1,'lostbyte',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2,NULL,NULL,'Получился не битрикс, и хорошо','<h3>Focktrix - не решение, но и не проблема</h3>\r\n<p>Было бы лучше, если бы не было хуже. Но нет. Не хуже. Спасибо, что посмотрели и изучили. Это главное!</p>',1698965757,0,1,'lostbyte',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3,NULL,NULL,'Нет. Ничего. Просто так','<h3>Focktrix - не битрикс, но и битрикс не фоктрикс</h3>\r\n<p>Вместе веселей. Скачай передай другому!</p>',1698965757,0,1,'lostbyte',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4,NULL,NULL,'Почему FocKtrix?','Во первых - уловка, во вторых код, в третьих для того чтобы кодить. Точнее меньше кодить - больше творить! Не было-б печали, если-бы не скачали. Если скачали - значит устали. Устали от головного битрикса мозга!',1698965757,1,1,'lostbyte',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5,NULL,NULL,'Процесс идёт, а идти не хочется...','Так-же как и прогресс. Прогрессировали, прогрессировали а фреймворка не сделали. Зачем б...ловчить, можно трюковать с код-уловками! Появилась функция exercept!',1698965757,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6,NULL,NULL,'Ну нет, нет... Нет! Не то!','Точнее то самое, просто не так. Обновлены некоторые компоненты, продолжается работа над пользовательскими фичами, продолжается нагрузка фреймворка вкусными и неочень функцианальными расширениями. Меньше боли - уменьшение разрыва в технических трюках между б... и кодУловкой.',1698965757,1,1,'lostbyte',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(8,NULL,NULL,'New new moscow never sleep','\"Фоктрикс\" - решение, дешевле чем корпоратив. Если трюкачить.<br>Всё просто - либо понятно, либо нет. Если нет, тогда выбора нет.<br>Это не продукт, конкретно сейчас - поставил и не знай проблем. Нет. Пока ручками. Головой.<UL>\r\n<LI>Модуль Balto - общение с telegram bot api.(Бесплатное коммерческое использование, при условии использовании основного продукта</LI>\r\n<LI>Модуль Kant - общение с вконтакте api (Бесплатное для коммерческих и некоммерческих организаций)</LI><LI>Модуль Qluiza - модуль викторин (текстовые квесты)(Бесплатное для коммерческих и некоммерческих организаций)</LI>\r\n</UL>\r\nС Новым, 2024-м Годом.<br>',1704054187,1,1,'lostbyte',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9,NULL,NULL,'FocКtrix - генерирует трюки, как из ведра изобилия!','Модуль Qrilo - позволяет генерировать QR код.<br> Для проверки достаточно <a href=\"/qr\">перейти и посмотреть в работе</a>.<br>Да, его \"подсмотрели\", да его переработали.<br> Но не всегда трючачить - значит изобретать велосипед. Иногда трюкачить - значит изобретать колесо ;)',1705507718,1,NULL,'lostbyte',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10,NULL,NULL,'Вероятность - стать канононом - не канонична! Особенно если ты вялешься на солнышке в ночь на 31-е января... Внеочередной чёс БИТРИКС!','Возможно FocКtrix - не сделает ставок, на то, что весь битрикс будет падать вплоть до 14 февраля по неизвестным причинам. FocКtrix - будет падать по известным. Дальше - хуже. И наоборот. Появился модуль Pregol - для парсинга, краулинга, разбора веб-страниц удалённых ресурсов. Не тех, которых удалились в результате опохмельного противостояния с 31-го декабря, на 31-е января... А тех, что далеко и не всегда под рукой. Помимо этого исправлено несколько ошибок роутера, поведения джаваскрипта и некоторых ошибок ядра в целом. Кроме - улучшен внутренний фреймворк для работы с CSS: улучшена пагинация и навбар. Спасибо, что не используете или используете. Это важно. Для битрикса. Для фоктрикса. Для отечественного Программного обеспечения. Примеры реализации и прототипов доступны на сайте <a href=\"https://hyperfeed.xyz\" target=\"_blank\">Калейдоскоп Ч/Б/Ц</a>',1698965757,0,1,'lostbyte',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(12,NULL,NULL,'FocКtrix - гражданский. Почти как семейный. Только с трюками!','Каждый знает, что битрикс - может! Может ли так FocКtrix - знает тот кто знает. Не может - значит не надо. Наконец! Началось. FocКtrix устал трюковать с главный файлом дистрибутива, на основе которого методами обратной (реверсивной) разборки - его самого! Теперь известно, как на самом деле выглядит битрикс FocКtrix - пример реализации битрикс? Нет. Пользуйтесь, выбирайте. Спасибо что не битрикс. Пусть',1706432360,1,NULL,'lostbyte',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13,NULL,NULL,'FocКtrix работает, даже когда совсем...','Точно сказать - не сказать ничего, так-же как и отличия в разных версиях. Что-то появилось, что-то исчезло. Главное - зачем-то и кому-то, возможно - пригодится.',1706658981,1,NULL,'lostbyte',NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14,NULL,NULL,'То-ли ещё будет. Не будет. Но потом или да.','<h3>FocКtrix - больная голова лекарства.</h3> Метод crsf блока - примитивно, но реализован. Не смотря на то, что новости нужно добавлять вручную - для тех, кто может их добавлять иначе - проблем остаётся меньше, как и головной боли. Кроме того - обзавёлся примитивным установщиком. Достаточно не обладать config.php - как rewrite_rules работают не стабильно. Всё очень примитивно и слабовато. Главное - работает. Без обвеса ценой человеческих...',1706788836,0,1,'lostbyte',NULL,NULL,NULL,NULL,NULL,NULL,NULL);
/*!40000 ALTER TABLE `news` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `roles`
--

DROP TABLE IF EXISTS `roles`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `roles` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  `privelegies` text DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `roles`
--

LOCK TABLES `roles` WRITE;
/*!40000 ALTER TABLE `roles` DISABLE KEYS */;
/*!40000 ALTER TABLE `roles` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rubricator`
--

DROP TABLE IF EXISTS `rubricator`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rubricator` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  `desc` text DEFAULT NULL,
  `url` text DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rubricator`
--

LOCK TABLES `rubricator` WRITE;
/*!40000 ALTER TABLE `rubricator` DISABLE KEYS */;
/*!40000 ALTER TABLE `rubricator` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `uploads`
--

DROP TABLE IF EXISTS `uploads`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `uploads` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  `path` text DEFAULT NULL,
  `random_name` text DEFAULT NULL,
  `url` text DEFAULT NULL,
  `date` text DEFAULT NULL,
  `owner` int(11) DEFAULT NULL,
  `visible` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `uploads`
--

LOCK TABLES `uploads` WRITE;
/*!40000 ALTER TABLE `uploads` DISABLE KEYS */;
/*!40000 ALTER TABLE `uploads` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `users`
--

DROP TABLE IF EXISTS `users`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  `desc` text DEFAULT NULL,
  `alias` text DEFAULT NULL,
  `role` int(11) DEFAULT NULL,
  `groups` text DEFAULT NULL,
  `email` text DEFAULT NULL,
  `password` text DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `users`
--

LOCK TABLES `users` WRITE;
/*!40000 ALTER TABLE `users` DISABLE KEYS */;
/*!40000 ALTER TABLE `users` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2024-02-04 23:18:22
