/*
ЧПП 0.5
автор lostbyte32@mail.com
ограничения - согласно j4l последней редакции, ЧПП само собой.
*/
class AssetManager {
    constructor(engine) {
        this.engine = engine;
        this.preloaded_assets = [];
    }

    addPreloadMultiAtlas(jsonUrl, callback) {
        const assetsManager = this;
        this.engine.loadTexturePack(jsonUrl, function(err, data) {
            if (!err) {
                for (const img of data) {
                    assetsManager.preloaded_assets.push(img);
                }
                return callback(assetsManager.preloaded_assets);
            }
        });
    }
}