/*
ЧПП 0.5
автор lostbyte32@mail.com
ограничения - согласно j4l последней редакции, ЧПП само собой.
*/
class Deck
{
	constructor(players, sceneObject)
	{
		this.players = players;
		this.dungeonCells = new Array();
		this.path = new Array();
		this.scene = sceneObject;
		this.cells = new Array();
		this.teleportDungeonPositions = new Array([0,8],[8,0],[12,16]);
		this.dungeonPlayerStartPos = new Array(this.teleportDungeonPositions[getRandomInt(2)]);
		console.log("start player pos is ", this.dungeonPlayerStartPos);
		this.roomGraph = new Array();
		this.dungeonDoorsPostions = new Array(
			[0,5, 'h'],/*[3,1],*/[4,0, 'v'],/*[12,3],*/[12,4,'h'],[8,6,'h'],
			[12,9,'h'],[10,12,'h'],[7,16,'v'],[0,14,'h'],[4,11,'h']
			);
		this.upLevelDoorsPositions = new Array(
			[7,3],[9,2],[10,2],[2,7],
			[1,12],[7,13],[7,14],
			[12,13],[12,14],[9,16],[10,16]
			);
		this.road = new Array(
			[4,0],[4,2], [4,4],[2,4],
			[0,4],[0,6],[0,8],[0,10],
			[2,10],[4,10],[4,12],[4,14],
			[4,16],[0,16],[2,16],[6,4],
			[6,6],[6,8],[8,8],[10,8],[12,8]


			/*
			[5,0],[4,1],[5,1],
			[5,2],[4,3],[5,3],
			[5,4],[4,5],[5,5],
			[1,4],[3,4],
			[0,5],[1,5],[2,5],[3,5],
			[7,4],[6,5],[7,5],
			[7,6],[6,7],[7,7],
			[7,8],[6,9],[7,9],
			[9,8],[8,9],[9,9],
			[11,8],[13,8],
			[10,9],[11,9],[12,9],[13,9],
			[1,6],[0,7],[1,7],
			[1,8],[0,9],[1,9],
			[1,10],[0,11],[1,11],
			[3,10],[5,10],
			[2,11],[3,11],[4,11],[5,11],
			[5,12],[4,13],[5,13],
			[5,14],[4,15],[5,15],
			[5,16],[4,17],[5,17],
			[1,16],[3,16],
			[0,17],[1,17],[2,17],[3,17]
			*/
			);
		this.blockRoad = new Array(
			[5,0],[4,1],[5,1],
			[5,2],[4,3],[5,3],
			[5,4],[4,5],[5,5],
			[1,4],[3,4],
			[0,5],[1,5],[2,5],[3,5],
			[7,4],[6,5],[7,5],
			[7,6],[6,7],[7,7],
			[7,8],[6,9],[7,9],
			[9,8],[8,9],[9,9],
			[11,8],[13,8],
			[10,9],[11,9],[12,9],[13,9],
			[1,6],[0,7],[1,7],
			[1,8],[0,9],[1,9],
			[1,10],[0,11],[1,11],
			[3,10],[5,10],
			[2,11],[3,11],[4,11],[5,11],
			[5,12],[4,13],[5,13],
			[5,14],[4,15],[5,15],
			[5,16],[4,17],[5,17],
			[1,16],[3,16],
			[0,17],[1,17],[2,17],[3,17]);
		this.roomsPositions = new Array(
			[3,0],[4,0],[3,1],[4,1], [5,0], 
			[5,1], [6,0], [6,1], [1,3], [2,3],
			[1,4],[2,4], [0,6], [0,7], [1,6],
			[1,7], [3,5],[3,6], [4,5],[4,6],
			[5,5], [5,6],[6,5], [6,6], [3,7],
			[4,7],[3,8],[4,8],[5,7],[5,8],[6,7],
			[6,8]);
		this.armoryPos = new Array([0,0],[1,0],[0,1],[1,1]);
		this.wizardTowerPos = new Array([4,2],[5,2],[6,2],[4,3],[5,3],[6,3]);
		this.teleportPositions = new Array([2,0],[0,8],[6,8]);
		this.eventsPositions = new Array([3,0],[4,0],[5,0],[6,1],[2,3],[1,4],[3,5],[5,5],[6,5],[1,6],[4,6],[1,7],[4,7],[5,7],[3,8]);
		this.roomsPositions1 = new Array(
			[1,13],[2,13],[1,14],[2,14],
							 [7,1], [8,1],[7,2],[8,2],[11,1],[12,1],[11,2],[12,2],
							[3,7],[4,7],[3,8],[4,8],[7,11],[8,11],[7,12],[8,12],[11,11],[12,11],[11,12],[12,12],
							[7,15],[8,15],[7,16],[8,16],[11,15],[12,15],[11,16],[12,16]			);
		this.armoryPositions1 = new Array(
					[1,1],[2,1], [1,2], [2,2]
			);
		this.wizzardTowerPositions = new Array(
					[9,5],[10,5],[11,5],[12,5],
					[9,6],[10,6],[11,6],[12,6]
			);
		/*
				this.dungeonRoomsPos = new Array(
			[1,1], [2,1], [1,2], [2,2], [1,3], [2,3],[1,4],[2,4],
			[3,9],[4,9],[3,10],[4,10],
			[5,1],[6,1],[5,2],[6,2],
			[7,7],[8,7],[7,8],[8,8],
			[11,1], [12,1],[11,2],[12,2],[11,5],[12,5],
			[11,6],[12,6],[11,7],[12,7],[11,8],[12,8],
			[1,15],[2,15],[1,16],[2,16],
			[5,15],[6,15],[5,16],[6,16],
			[9,13],[10,13],[9,14],[10,14]
			);
		*/
		this.dungeonRoomsPos = new Array(
			[0,0], [2,0], [0,2], [2,2], [0,4], [2,4],/*[1,4],[2,4],*/
			[2,8],[4,8],[2,10],[4,10],
			[4,0],[6,0],[4,2],[6,2],
			[6,6],[8,6],[6,8],[8,8],
			[10,0], [12,0],[10,2],[12,2],[10,4],[12,4],
			[10,6],[12,6],[10,8],[12,8],/*[10,10],[12,10],*/
			[0,14],[2,14],[0,16],[2,16],
			[4,14],[6,14],[4,16],[6,16],
			[8,12],[10,12],[8,14],[10,14]
			);
		this.dungeonRoad = new Array(
			[8,0],[8,2], [8,4], [6,4],[4,4], [4,6], [2,6], [0,6],
			[0,8],[0,10],[0,12],[2,12],[4,12],[6,10],[6,12],[8,10],
			[10,10],[12,10],[12,12],[12,14],[12,16],[10,16], [8,16]
			/*
			*/);
		
		this.blockDungeonRoad = new Array(
			[8,1],[0,8],[1,8], /*[8,2],*/[8,5],/*[6,4],[4,4],[1,6], [2,6],*/
			[4,7],[1,9],[1,10],[1,13],[3,12],/*[4,12],[6,10],*/
			[7,13],[9,11],[10,11],[12,11],[12,13]/*,[12,14],[9,16]*/
			/*[12,16],[10,16]*/);
		this.buildField();
		this.pathfinderGraph = new Graph(this.buildDungeon());
		//console.log(this.pathfinderGraph);

	}

	buildDungeon()
	{
		for (let cols=0;cols<FIELD_WIDTH;cols++)
	  	{
	    	this.roomGraph[cols]=[];
		    for (let rows=0;rows<FIELD_HEIGHT;rows++)
		    {
		      let cell = this.scene.add.rectangle(380+(cols*(CELL_SIZE+1)), rows*(CELL_SIZE+1), CELL_SIZE, CELL_SIZE, 0xff0000).setOrigin(0);
			  //cell.setDepth(1);
			  this.roomGraph[cols][rows]=1;
			  cell.setDataEnabled();
		      cell.data.set('col', cols);
			  cell.data.set('row', rows);
			  cell.data.set('cell_', true);
				for (const x of this.dungeonRoad)
				{
					if (x[0]==cols && x[1]==rows)
					{
						cell.width = cell.width*2;
						cell.height = cell.height*2;
						cell.fillColor=0x979A9A ;
						cell.setDepth(1);
						cell.data.set('cell_', false);
						this.roomGraph[cols][rows]=1;
					}
				}
				for (const x of this.dungeonRoomsPos)
				{
					if (x[0]==cols && x[1]==rows)
					{
						cell.fillColor=0xffffff;
						cell.data.set('cell_', false);
						cell.width = cell.width*2;
						cell.height = cell.height*2;
						this.roomGraph[cols][rows]=1;

					}
				}
				for (const x of this.dungeonDoorsPostions)
				{
					if (x[0]==cols && x[1]==rows)
					{
						let door = this.scene.add.rectangle(380+(cols*(CELL_SIZE+1)), rows*(CELL_SIZE+1), CELL_SIZE, CELL_SIZE, 0xff0000).setOrigin(0);
						door.setDataEnabled();
						door.fillColor=0x117A65;
						door.data.set('cell_', false);
						door.setDepth(1);
						if (x[2]=='v')
						{
							door.height = door.height*2;
						}
						else if (x[2]=='h')
							door.width = door.width*2;
						
					this.roomGraph[cols][rows]=0;
					}
				}
				

				for (const x of this.blockDungeonRoad)
				{
					if (x[0]==cols && x[1]==rows)
					{
						cell.data.set('cell_', true);
						this.roomGraph[cols][rows]=1;
						
					}
				}
			
			if (cell.data.get('cell_'))
			{

				cell.width=0;
				cell.height=0;
			}	
			
			/*else
			{
				cell.width = cell.width*2;
				cell.height = cell.height*2;
			}
			*/
			  
		   
		    
		    this.initInput(cell);
		    this.dungeonCells.push(cell);
 		}
	  }
	  if (this.roomGraph)
	  	return this.roomGraph;
	}

	buildField()
	{
	  	for (let cols=0;cols<FIELD_WIDTH;cols++)
	  	{
	    	//roomArray[cols]=[];
		    for (let rows=0;rows<FIELD_HEIGHT;rows++)
		    {																				//25		25
		      let cell = this.scene.add.rectangle(cols*(CELL_SIZE+1), rows*(CELL_SIZE+1), CELL_SIZE, CELL_SIZE, 0xff0000).setOrigin(0);
			  //cell.setDepth(1);
			  cell.setDataEnabled();
		      cell.data.set('col', cols);
			  cell.data.set('row', rows);
			  	/*
			  	for (const x of this.teleportPositions)
			  	{
			  		if (x[0]==cols && x[1]==rows)
			  		{
			  			 let mark = this.scene.add.ellipse(x[0]*(CELL_SIZE+1)+8.6, x[1]*(CELL_SIZE+1)+8.6, CELL_SIZE/2, CELL_SIZE/2, 0x008000).setOrigin(0);
			  			 mark.setDepth(1);
			  		}
			  	}

			  	for (const x of this.eventsPositions)
			  	{
			  		if (x[0]==cols && x[1]==rows)
			  		{
			  			 let eventMarker = this.scene.add.ellipse(x[0]*(CELL_SIZE+1)+8.6, x[1]*(CELL_SIZE+1)+8.6, CELL_SIZE/2, CELL_SIZE/2, 0xddd4ca).setOrigin(0);
    					 eventMarker.setDepth(1);
			  		}
			  	}
				*/
				
				for (const x of this.road)
				{
					if (x[0]==cols && x[1]==rows)
					{
						cell.width = cell.width*2;
						cell.height = cell.height*2;
						cell.fillColor=0x979A9A ;
						cell.setDepth(1);
					}

				}
				for (const x of this.roomsPositions1)
				{
					if (x[0]==cols && x[1]==rows)
					{
						cell.fillColor=0xffffff;
					}
				}
				for (const x of this.upLevelDoorsPositions)
				{
					if (x[0]==cols && x[1]==rows)
						cell.fillColor=0x117A65;
				}
				for (const x of this.armoryPositions1)
				{
					if (x[0]==cols && x[1]==rows)
					{
						cell.fillColor=0x0000ff;
					}
				}

				for (const x of this.wizzardTowerPositions)
				{
					if (x[0]==cols && x[1]==rows)
					{
						cell.fillColor=0xff8000;

					}
				}
				

			  this.initInput(cell);
		      this.cells.push(cell);
		    }

	  }
  		//return roomArray;
	}

	placeTeleports()
	{

	}

	initInput(cell)
	{	      
		cell.setInteractive();
		const deck = this;
		cell.on('pointerdown', function()
		{
			let col = cell.data.get('col');
			let row = cell.data.get('row');
			console.log("col: ", cell.data.get('col'), "row: ", cell.data.get('row'));
			if (deck.path)
          	{
              for (const cellGlow of deck.path)
              {
                cellGlow.fillColor=0xff0000;
              }
              deck.path = [];
          	}
			if (deck.pathfinderGraph)
			{
				let start = deck.pathfinderGraph.grid[8][0];
            	let end = deck.pathfinderGraph.grid[col][row];
            	let result = astar.search(deck.pathfinderGraph, start, end);
            	if (result)
            	{
            		console.log("path is ", result);
            		for (const res of result)
            		{
              			for (const glowCell of deck.dungeonCells)
              			{
                			if (glowCell.data.get('row')==res.y && glowCell.data.get('col')==res.x || glowCell.data.get('row')==startPosition[1] && glowCell.data.get('col')==startPosition[0])
                			{
                    			glowCell.fillColor=0xF1C40F;
                   				deck.path.push(glowCell);

                			}
              			}
            		}
            	}
			}
	
		});
	}

	buildRooms()
	{

	}

}