/*
ЧПП 0.5
автор lostbyte32@mail.com
ограничения - согласно j4l последней редакции, ЧПП само собой.
*/
class ImageConverter {
    constructor() {

    }
    static cropImage(image, sx, sy, sWidth, sHeight, dx, dy, dWidth, dHeight, callback) {
        let canvas = document.getElementById('game_wall');
        if (!canvas)
            canvas = document.createElement('canvas');
        canvas.style.display = 'none';
        const context = canvas.getContext('2d');
        if (context) {
            canvas.width = image.width;
            canvas.height = image.height;
            context.clearRect(0, 0, canvas.width, canvas.height);
        }
        context.drawImage(image.img, sx, sy, sWidth, sHeight, dx, dy, dWidth, dHeight);
        const img = new Img(image.getName(), canvas.toDataURL('image/png'));
        img.width = image.width;
        img.height = image.height;
        if (img)
            return callback(null, img);
        else
            return (new Error('Crop error'));
    }

    static scaleImage(image, width, height) {
        let canvas = document.getElementById('game_wall');
        if (!canvas)
            canvas = document.createElement('canvas');
        canvas.style.display = 'none';
        const context = canvas.getContext('2d');
        if (context) {
            canvas.width = image.width;
            canvas.height = image.height;
            context.clearRect(0, 0, canvas.width, canvas.height);
        }
        context.drawImage(image.getImage(), 0, 0, width, height);
        const img = new Img(image.name, canvas.toDataURL('image/png'));
        return img;
    }
}