/*
ЧПП 0.5
автор lostbyte32@mail.com
ограничения - согласно j4l последней редакции, ЧПП само собой.
*/
class Img {
    constructor(name, url, x, y) {
        this.img = new Image();
        if (url)
            this.img.src = url;
        this.img.name = name;
        this.name = name;
        this.src = url;
        this.pos_x = x;
        this.pos_y = y;
        this.visible = true;
        this.static = true;
        this.inMove = false;
        this.animation = null;
        this.visible = true;
        this.needUpdate = false;
        //engine.addToRender(this);
        //
        this.events = [];
        this.anims = [];
        this.markUpdate();
        //this.onload = callback
    }

    isNeedUpdate() {
        return this.needUpdate;
    }


    markUpdate() {
        this.needUpdate = true;
    }

    update() {
        const img = this.img;
        if (this.needUpdate) {
            this.needUpdate = false;

            this.img.style.top = this.pos_y = "px";
            this.img.style.left = this.pos_x + "px";


            if (this.events.length) {

                this.events.forEach((eventData) => {
                    img.addEventListener(eventData.event, () => {
                        eventData.callbackFunction();
                    });
                })

            }
        }

    }

    addAnimation(anim) {
        this.anims.push(anim);
    }

    addEvent(event = "pointerdown", callbackFunction) {
        const img = this.img;
        this.events.push({ event: event, callbackFunction: callbackFunction });

        img.addEventListener(event, (internal) => {
            console.log('test');
            callbackFunction();
        });

    }

    setActive(state) {
        this.visible = state;
    }

    getName() {
        return this.name;
    }

    getImage() {
        return this.img;
    }

    getUrl() {
        return this.src;
    }

    setDataEnabled() {
        this.data = {};
    }

    setData(key, data) {
        // there is other way?
    }


}