/*
ЧПП 0.5
автор lostbyte32@mail.com
ограничения - согласно j4l последней редакции, ЧПП само собой.
*/
class Preloader {
    constructor() {
        this.images = [];

        this.lastLoadIsComplete = false;

    }

    preloadImage(img_name, url, pos_vector = { x: 0, y: 0 }, callback) {

        const img = new Img(img_name, url, pos_vector.x, pos_vector.y);
        let body = document.getElementById("preloader_active_html");
        if (body) {
            let preload_image = document.createElement('link');
            preload_image.rel = "preload";
            preload_image.href = url;
            preload_image.as = "image";
            body.appendChild(preload_image);
        }
        img.img.onload = callback;

        callback(img);
    }

    preloadImages(urls_array) {
        const preloader = this;
        urls_array.forEach((url) => {
            console.log(url);
            preloader.preloadImage(url.texture_name, url.url, { x: 0, y: 0 }, (img) => {

            });
        });
    }

    getImageByName(img_name, callback) {
        let img = null;
        const preloader = this;
        let error = new Error(1);
        preloader.images.forEach((image) => {
            if (image) {
                if (image.name === img_name) {

                    img = image;
                    error = null;
                }
            }

        });
        callback(error, img);
    }
}
