/*
ЧПП 0.5
автор lostbyte32@mail.com
ограничения - согласно j4l последней редакции, ЧПП само собой.
*/
class Helper {
    resizeTimer() { };

    static get_time() {
        return parseInt(new Date().getTime() / 1000);
    };
    static getRandomInt(max) {
        return Math.floor(Math.random() * Math.floor(max));
    }

    static remove_from_array(arr, value) {
        var b = '';
        for (b in arr) {
            if (arr[b] === value) {
                arr.splice(b, 1);
                break;
            }
        }
        return arr;
    }
    static remove_from_array_safe(arr, value) {
        const copy = [...arr];
        var b = '';
        for (b in copy) {
            if (arr[b] === value) {
                copy.splice(b, 1);
                break;
            }
        }
        return copy;
    };
    static cloneObject(obj) {
        obj = obj && obj instanceof Object ? obj : '';

        if (obj instanceof Date) {
            return new Date(obj);
        }

        if (obj instanceof Array) {
            return obj.slice();
        }

        if (obj instanceof Object) {
            var copy = new obj.constructor();
            for (var attr in obj) {
                if (obj.hasOwnProperty(attr)) {
                    if (obj[attr] instanceof Object) {
                        copy[attr] = this.cloneObject(obj[attr]);
                    } else {
                        copy[attr] = obj[attr];
                    }
                }
            }
            return copy;
        }

        throw new Error("Unable to copy obj! Its type isn't supported.");
    };

    static isEmpty(obj) {
        return Object.keys(obj).length === 0;
    };

    static get_last(arr) {
        return [...arr].pop();
    };

    static count(ary, classifier) {
        classifier = classifier || String;
        return ary.reduce(function (counter, item) {
            var p = classifier(item);
            counter[p] = counter.hasOwnProperty(p) ? counter[p] + 1 : 1;
            return counter;
        }, {});
    };

    static isFunction(functionToCheck) {
        let result = false;
        if (typeof functionToCheck === 'function') {
            result = true;
        }

        return result;
    };

    static clone(a) {
        return JSON.parse(JSON.stringify(a));
    };

    static distanceBeetwen(x1, y1, x2, y2) {
        const dist = Math.sqrt((x2 - x1) ** 2 + (y2 - y1) ** 2);
        return Math.floor(dist);
    };

    static multipleMax(arr) {

        var maxvalue = Math.max(...arr);
        var maxIndexes = [];

        for (i = 0; i < arr.length; i++) {
            if (arr[i] == maxvalue) {
                maxIndexes.push(i);
            };
        };
        return maxIndexes;
    };
    static multipleMin(arr) {

        var minvalue = Math.min(...arr);
        var minIndexes = [];

        for (i = 0; i < arr.length; i++) {
            if (arr[i] == minvalue) {
                minIndexes.push(i);
            };
        };
        return minIndexes;
    };
    static loadFont(name, url) {
        var newFont = new FontFace(name, `url(${url})`);
        newFont.load().then(function (loaded) {
            document.fonts.add(loaded);
        }).catch(function (error) {
            return error;
        });
    };
    static get_index(elem, array) {
        let index = null;
        let count = 0;
        for (const inArray of array) {
            if (inArray === elem) {
                index = count;

            }
            count++;
        }
        return index;
    };
    static sort_array(array) {
        const sorted = array.sort(function (a, b) {
            return a.contest_priority - b.contest_priority;
        });
        return sorted.reverse();
    };
    static sort_contest_to_win(array) {
        const sorted = array.sort(function (a, b) {
            return a.contest_priority - b.contest_priority;
        });
        return sorted.reverse();
    };
    static sort_contest_to_loose(array) {
        const sorted = array.sort(function (a, b) {
            return b.contest_priority - a.contest_priority;
        });
        return sorted.reverse();
    };

};

class MMath {

}