/*
this code under free to learn and exploration use,
there is covered GNU/GPL3 (as part of j4l no-care restrictions, just idea), with j4l restrictions:
you can modify, but not redist as anything, what that is not cost.
be ready for carmic destruction.
there is no way to cover obfusc on it - there is big question of life, universe and something other etc.
you can use it on production, with all over you modifications, you can install it for any non-commercial structures,
or with mailing to lostbyte32@gmail.com, with words: 'we want it', and take any representable answer for "why".
code is free to use, learn and research.

code redistutable as it and nobody care, for free exactly? with free to use, but with original link or hand-to-hand redistribution.
j4l 0.0.4 Common Annual Part Restrictions And No Cares Waranty Happens, self-licensed and as it 04.11.2023
*/
/*
at frirst we must cgeck last updatet cached?
with ajax, and there is update if that running out, or with calendar time
next we must apply to page there is lot stuff.
or show cached!
*/
let installed = false;
class StorageManagerEx {
    constructor() {
        this.store = null;
        this.updated = false;
        this.failed = false;
        this.navigator = window.navigator;


        this.init();
    }

    install() {
        if (installed)
            return;
        this.app_name = document.getElementById('feed');
        if (!this.app_name) {
            this.failed = true;
        }
        this.app_name = this.app_name.textContent;
        let data = this.app_name.split('::')[0].replace('\n', '').replaceAll(' ', '');
        this.app_name = data;
        installed = true;
        let navigator = null;
        const store = this;
        if ('serviceWorker' in this.navigator) {
            navigator = this.navigator;
            this.navigator.serviceWorker.register(
                '/кэш.js', {
                scope: "/",
            }
            ).then(function (registration) {
                // при удачной регистрации имеем объект типа ServiceWorkerRegistration  
                caches.open(store.app_name).then(function (cache) {

                    return cache.add(location.pathname);
                })
                // строкой ниже можно прекратить работу serviceWorker’а
                //registration.unregister();
            }).catch(function (err) {
                throw new Error('ServiceWorker error: ' + err);
            });
        }

    }

    loadSavedFiles(saved_data_block) {
        for (let x = 0; x < this.store.length; x++) {
            const doc = this.store.key(x);
            if (doc.includes('document_')) {
                const href = document.createElement('a');
                href.setAttribute('href', '#');
                href.innerHTML = this.store.key(x);
                saved_data_block.append(href);
                href.addEventListener('click', (e) => {
                    const editor = window.editor.currentEditor;
                    if (editor) {
                        if (editor.getAttribute('class') === 'editor') {
                            editor.innerHTML = window.store.getData(href.innerHTML);

                        }
                        else {

                            editor.textContent = window.store.getData(href.innerHTML);
                            window.editor.highLite(editor);
                        }
                    }
                })
            }

        }
    }

    saveDoc(name = '', data) {
        this.setData('document_' + name, data);
    }

    loadCache() {
        const saved_data_block = document.getElementById('saved_files');
        if (saved_data_block) {
            this.loadSavedFiles(saved_data_block);
        }
    }

    init() {



        this.store = localStorage;
        //we must put script with load data of storage.
        // first we must 
        this.loadCache();
    }



    checkIsExist(key) {
        if (this.getData(key))
            return true;
        return false;
    }

    setData(block, data) {
        this.store.setItem(block, data);
    }

    getData(block) {
        return this.store.getItem(block);
    }

    getDataPretty(response) {
        if (!isJsonString(response)) {
            return;
        }
        const data = JSON.parse(response);
        return { 'page': data['page'], 'fp': data['fpid'], 'last': data['lastid'] };
    }

    removeData(block) {
        this.store.removeItem(block);
    }
    static delete_cookie(name, path, domain) {
        if (StorageManagerEx.get_cookie(name)) {
            document.cookie = name + "=" +
                ((path) ? ";path=" + path : "") +
                ((domain) ? ";domain=" + domain : "") +
                ";expires=Thu, 01 Jan 1970 00:00:01 GMT";
        }
    }
    static get_cookie(name) {
        let matches = document.cookie.match(new RegExp(
            "(?:^|; )" + name.replace(/([\.$?*|{}\(\)\[\]\\\/\+^])/g, '\\$1') + "=([^;]*)"
        ));
        return matches ? decodeURIComponent(matches[1]) : undefined;
    }

    static setCookie(cName, cValue, expDays) {
        let date = new Date();
        date.setTime(date.getTime() + (expDays * 24 * 60 * 60 * 1000));
        const expires = "expires=" + date.toUTCString();
        document.cookie = cName + "=" + cValue + "; " + expires + "; path=/";
    }

    checkForUpdate(page, callback) {
        let cookie = StorageManagerEx.get_cookie('cached');

        if (!cookie) {
            StorageManagerEx.setCookie('cached', Helper.get_time(), 1);
        }
        else {

            if (parseInt(cookie) + 1800 > Helper.get_time()) {
                StorageManagerEx.delete_cookie('cached');
                cookie = null;
            }
        }
        if (!cookie) {
            this.checkForReset(page);
        }
    }
    checkForReset(page) {
        if (!page)
            return;
        if (this.getData('page_' + page)) {
            window.stop();
            this.applyCache();
        }
        else if (this.navigator.onLine) {
            const manager = this;
            if (page.length > 2)
                return;
            setTimeout(() => {
                var xhttp = new XMLHttpRequest();
                xhttp.open("POST", "/cache", true);
                xhttp.withCredentials = true;
                xhttp.setRequestHeader('Content-Type', 'application/json');
                xhttp.onreadystatechange = function () {
                    if (this.readyState == 4 && this.status == 200) {
                        var response = this.responseText;
                        let data = this.getDataPretty(response);
                        manager.removeData('page_' + data['page']);
                        manager.setData('page_' + data['page']);
                        manager.writePageToCache(data['page']);
                        data = new FormData();
                        data.append('page', page);
                        xhttp.send(data);
                    }
                }
            }, 1500
            )


        }
    }
    reset() {
        this.store.clear();
    }

    getCurrentPage() {
        let path = window.location.pathname.split('/');
        let query = path[path.length - 1];
        let page = parseInt(query);
        if (!page)
            page = 1;
        return page;
    }

    applyCache() {
        const news_block = document;
        if (news_block) {
            const data = this.getData('page_' + this.getCurrentPage());
            news_block.innerHTML = data;
        }
    }

    writePageToCache(page) {
        const news_block = document;
        if (news_block) {
            this.setData('page_' + page, news_block.innerHTML);
        }
        else { }
    }


}
