<?php
/*
this code under free to learn and exploration use,
there is covered GNU/GPL3, with j4l restrictions:
you can modify, but not redist as anything, what that is not cost.
be ready for carmic destruction.
there is no way to cover obfusc on it - there is big question of life, universe and something other etc.
you can use it on production, with all over you modifications, you can install it for any non-commercial structures,
or with mailing to lostbyte32@gmail.com, with words: 'we want it', and take any representable answer for "why".
code is free to use, learn and research.

code redistutable as it and nobody care, for free exactly? with free to use, but with original link or hand-to-hand redistribution.
j4l 0.0.4 Common Annual Part Restrictions And No Cares Waranty Happens, self-licensed and as it 12.12.2023
*/
namespace Files;

use App\Focker;
use Helper\Enums;
use Helper\SystemHelper;
use Logger\LogDebug;
use SplFileInfo;

class FileWorker
{

    public static $counter;
    public static function read_file_as_string($filepath)
    {
        return file_get_contents($filepath);
    }

    public static function get_file_path($file): ?string
    {
        $path = dirname($file);
        return $path;
    }
    public static function level_up_dir($dir)
    {
        chdir($dir);
        chdir('../');
        return getcwd();
    }

    public static function get_file_extension_native($file)
    {
        return pathinfo($file, PATHINFO_EXTENSION);
    }

    public static function check_file_is_image($file)
    {
        $mime = mime_content_type($file);
        return in_array($mime, Enums::IMAGE_MIME_TYPES);
    }

    public static function getFileExtension($file): string
    {
        $parts = explode('/', $file);
        $extension = null;
        if ($parts) {
            $file = end($parts);
            $ext = explode('.', $file);
            $extension = end($ext);

        }
        return $extension;
    }

    public static function is_dir($file)
    {
        return is_dir($file);
    }
    public static function get_file_creation_time($dirname)
    {
        $time = null;
        if (self::is_file($dirname))
            $time = filemtime($dirname);
        return $time;
    }
    public static function read_file_as_array($filepath): array
    {
        $read_lines = null;
        if (file_exists($filepath)) {
            $handle = fopen($filepath, "r");
            $read_lines = [];
            if ($handle) {
                while (($line = fgets($handle)) !== false) {
                    $read_lines[] = $line;
                }
                fclose($handle);
            }
        }
        return $read_lines;
    }
    private static function write_line($filepath, $line)
    {
        $handle = fopen($filepath, 'a+');
        try {
            fwrite($handle, $line . PHP_EOL);
        } catch (\Exception $e) {
            //LogDebug::dump_log($e);
            return false;
        }
        fclose($handle);
        return true;
    }

    public static function create_gzip($files = [])
    {
        foreach ($files as $file) {
            if (self::is_file($file)) {
                $fil = $file;
                $filgz = $fil . '.gz';
                file_put_contents($filgz, gzencode(file_get_contents($fil), 9));
            }

        }
    }

    public static function try_appen_to_file($filename, $data)
    {
        file_put_contents($filename, print_r($data, true) . PHP_EOL, FILE_APPEND);
    }
    public static function convert_to_json($data)
    {
        $json = json_encode($data);
        return $json;
    }
    public static function read_json($data)
    {
        return json_decode($data);
    }
    public static function write_file($filepath, $data)
    {
        if (self::is_file($filepath)) {
            if (is_array($data)) {
                foreach ($data as $line) {
                    self::write_line($filepath, $line);
                }
            } else {
                self::write_line($filepath, $data);
            }
        } else
            try {
                self::create_file($filepath);
            } catch (\Exception $e) {
                LogDebug::dump_log($e);
            }
    }

    public static function create_file($filepath)
    {
        if (!self::is_file($filepath)) {
            $myfile = fopen($filepath, "w+");
            if ($myfile) {
                fclose($myfile);
                return true;
            }
        }
        return false;
    }

    public static function write_file_data($filepath, $data)
    {
        return file_put_contents($filepath, print_r($data, true) . PHP_EOL, FILE_APPEND);
    }

    public static function remove_file($filepath)
    {
        $result = false;
        if (!self::is_file($filepath))
            return;
        if (!unlink($filepath)) {
            $result = false;
        } else {
            $result = true;
        }
        return $result;
    }
    public static function check_file_permissions($file)
    {
        return decoct(fileperms($file) & 0777); //php.net
    }

    public static function is_file($filepath)
    {
        return file_exists($filepath);
    }
    public static function flushFile($filepath)
    {
        $file = fopen($filepath, "w");
        fclose($file);
    }
    public static function emulateAsyncReadDirectories()
    {
        // $basedir+'
        // prepare file for write?
    }
    //there is very hard part of undestanding under recursive alg;
    public static function read_full_dir($dir)
    {
        $results = self::read_dir_recursive($dir);
        return $results;
    }

    public static function file_exist_ex($file)
    {
        @$result = fopen($file, 'r');
        if ($result) {
            fclose($result);
            $result = true;
        }

        return $result;
    }

    public static function read_dir_recursive($dir, &$results = array())
    {
        $files = scandir($dir);
        foreach ($files as $key => $value) {
            $path = realpath($dir . DIRECTORY_SEPARATOR . $value);
            if (!is_dir($path)) {
                $results[self::$counter] = $path;
            } else if ($value != "." && $value != "..") {
                self::read_dir_recursive($path, $results);
                $results[self::$counter] = $path;
            }
            self::$counter++;
        }
        return $results;
    }
    public static function get_file_in_dir_by_id($dirname, $id)
    {
        $files = self::read_full_dir($dirname);
        $file_name = null;
        foreach ($files as $file_id => $path) {
            if ($file_id == $id) {

                $file_name = $path;
            }
        }
        $data = null;
        if ($file_name && !strpos($file_name, 'config.php') && !strpos($file_name, 'log.smg')) {
            $data = self::read_file_as_string($file_name);
        }
        return $data;
    }
    public static function look_over_dir($dirname)
    {
        $dir_data = null;
        $dir_data = scandir($dirname);
        return $dir_data;
    }
    public static function write_to_line_file($filepath, $line)
    {
    }
    //php.net?
    public static function save_upload_files()
    {
        $files = Focker::$app->files;
        $result = null;
        if (!empty($files)) {
            $total_count = count($files);
            for ($i = 0; $i < $total_count; $i++) {
                $tmpFilePath = $files['file_' . $i]['tmp_name'];
                if ($tmpFilePath != "") {
                    $file_name = $files['file_' . $i]['name'];
                    $newFilePath = Focker::$app->upload_dir . $file_name;
                    if (self::check_file_is_image($tmpFilePath)) {
                        $upload_endpoint = Focker::$app->site_url . '/' . Focker::$app->uploads_dir . $file_name;
                        $result = move_uploaded_file($tmpFilePath, $newFilePath);
                        if ($result) {
                            $result = ['res' => Enums::FILE_UPLOAD_DONE, 'file' => $upload_endpoint, 'type' => Enums::FILE_IS_IMAGE];
                        }
                    }

                }
            }
        }
        return json_encode($result);
    }
}