<?php
namespace Helper;

class ImageProcessor
{
    public static function create_image(string $from_image = null, $options = ['width' => 200, 'height' => 200, 'x' => 0, 'y' => 0])
    {
        $image = null;
        if ($from_image) {
            $image = imagecreatefrompng($from_image);
        }
        return $image;

    }

    public static function add_text($image, $text = 'ya lbly ibszsa', $font_size = 22, $angle = 0, $x = 0, $y = 0, $color = [66, 182, 66], $font = null)
    {
        $color = imagecolorallocate($image, $color[0], $color[1], $color[2]);
        return imagefttext($image, $font_size, $angle, $x, $y, $color, $font, $text);
    }

    public static function render_image($image)
    {
        header('Cache-Control: no-store, must-revalidate');
        header('Expires: 0');
        header('Content-Type: image/png');
        imagepng($image);
        imagedestroy($image);
    }
}