<?php
/*
this code under free to learn and exploration use,
there is covered GNU/GPL3, with j4l restrictions:
you can modify, but not redist as anything, what that is not cost.
be ready for carmic destruction.
there is no way to cover obfusc on it - there is big question of life, universe and something other etc.
you can use it on production, with all over you modifications, you can install it for any non-commercial structures,
or with mailing to lostbyte32@gmail.com, with words: 'we want it', and take any representable answer for "why".
code is free to use, learn and research.

code redistutable as it and nobody care, for free exactly? with free to use, but with original link or hand-to-hand redistribution.
j4l 0.0.4 Common Annual Part Restrictions And No Cares Waranty Happens, self-licensed and as it 12.12.2023
*/
namespace Helper;

class SystemHelper
{
    public static function mb_ucfirst($string, $encoding = 'UTF-8') //part of stackoverflow
    {
        $firstChar = mb_substr($string, 0, 1, $encoding);
        $then = mb_substr($string, 1, null, $encoding);
        return mb_strtoupper($firstChar, $encoding) . $then;
    }

    public static function pretty_url(string $url)
    {
        return urldecode($url);
    }

    public static function convert_utf8(string $context, $html = "HTML-ENTITIES", $encoding = 'UTF-8')
    {
        $result = null;
        if ($html)
            $result = mb_convert_encoding($context, $html, $encoding);
        else
            $result = mb_check_encoding($context, $encoding);
        return $result;
    }

    public static function utf8_cyrillic_fix($string)
    {
        return iconv("Windows-1252", "UTF-8", $string);
    }

    public static function first_of_iter(iterable $iterable, $default = null)
    {
        foreach ($iterable as $item) {
            return $item;
        }
        return $default;
    }

    public static function convert_iter_to_arr($iter): ?array
    {
        return iterator_to_array($iter);
    }

    public static function getHostname()
    {
        return $_SERVER['SERVER_NAME'];
    }
    public static function getUri(): array
    {
        $path = $_SERVER['REQUEST_URI'] ?? '/';
        return explode('/', $path);
    }

    public static function getRequestUri()
    {
        return $_SERVER['REQUEST_URI'];
    }
    public static function sage_string($string)
    {
        $string = stripslashes($string);
        $string = strip_tags($string);

        return $string;
    }

    public static function sha_pass($user, $pass)
    {
        $user = strtoupper($user);
        $pass = strtoupper($pass);

        return SHA1($user . ':' . $pass);
    }

    public static function convertToRussianTimeFromUts($date) //hack move to soemthig
    {
        // https://vitalik.ws/zametki/78-nazvanie-mesyaca-data-na-russkom-yazyke-s-pomoshyu-php.html
        $_timestampDate = $date;
        $currentDate = date("d.m.Y", $_timestampDate);
        $_monthsList = array(
            ".01." => "января",
            ".02." => "февраля",
            ".03." => "марта",
            ".04." => "апреля",
            ".05." => "мая",
            ".06." => "июня",
            ".07." => "июля",
            ".08." => "августа",
            ".09." => "сентября",
            ".10." => "октября",
            ".11." => "ноября",
            ".12." => "декабря"
        );
        $_mD = date(".m.", $_timestampDate);
        $currentDate = str_replace($_mD, " " . $_monthsList[$_mD] . " ", $currentDate);
        return $currentDate;
    }

    public static function fix_slashes($string)
    {
        return str_replace("\\", "/", $string);
    }
    public static function array_exclude($array, array $excludeKeys)
    {
        foreach ($excludeKeys as $key) {
            unset($array[$key]);
        }
        return $array;
    }

    public static function array_exclude_value($array, array $values)
    {
        foreach ($array as $k => $val) {
            foreach ($values as $key) {
                if ($val == $key)
                    unset($array[$k]);
            }
        }
        return $array;
    }

    public static function filter_requests() //stackoverflow
    {
        foreach ($_GET as $key => $value) {
            $_GET[$key] = self::filter($value);
        }
        foreach ($_POST as $key => $value) {
            $_POST[$key] = self::filter($value);
        }
    }

    public static function filter($data) //part of stackoverflow
    {
        //primitive native filtering, not at all
        $data = trim($data);
        $data = strip_tags($data);
        $data = htmlentities($data);
        return $data;
    }

}
