<?php
/*
this code under free to learn and exploration use,
there is covered GNU/GPL3, with j4l restrictions:
you can modify, but not redist as anything, what that is not cost.
be ready for carmic destruction.
there is no way to cover obfusc on it - there is big question of life, universe and something other etc.
you can use it on production, with all over you modifications, you can install it for any non-commercial structures,
or with mailing to lostbyte32@gmail.com, with words: 'we want it', and take any representable answer for "why".
code is free to use, learn and research.

code redistutable as it and nobody care, for free exactly? with free to use, but with original link or hand-to-hand redistribution.
j4l 0.0.4 Common Annual Part Restrictions And No Cares Waranty Happens, self-licensed and as it 12.12.2023
*/
namespace Models;

use Config as config;
use Helper\Enums;
use Helper\StringHelper;
use Helper\TimeHelper;
use Widgets\Pagination;
use App\Focker;

class News extends ActiveRecord
{
    // private $drop_list = array();

    public function __construct() /*void:*/
    {
        $this->setName('news');
    }

    public function GetById($id) /*void:*/
    {
        $this->select()->where('guid', $id);
        return Focker::$db->queryBuilder->execute();
    }

    public function getAll($page = null, $city = null, $rubric = null, $pagination_size = 5, $order_by = "guid", $order = "DESC")
    {
        //first we must to load as with limit, there is must be builder
        // as how we must to do that?
        if (!$page || StringHelper::is_string($page))
            $page = 1;
        $this->select();
        if ($city) {
            Focker::$db->queryBuilder->where('city_id', $city);
        }
        if ($rubric && $city) {

            Focker::$db->queryBuilder->andWhere('rubricator', $rubric);
        }
        if ($rubric && !$city) {
            Focker::$db->queryBuilder->where('rubricator', $rubric);
        }
        if (!$rubric && !$city) {
            //Focker::$db->queryBuilder->where('rubricator', 0);
        }
        $rows_count = Focker::$db->queryBuilder->count();
        $pagination = Pagination::calc((int) $page, $rows_count, $pagination_size);
        Focker::$db->queryBuilder->setOrder($order_by, $order);
        Focker::$db->queryBuilder->setLimits($pagination['offset'], $pagination['perPage']);
        $rows = Focker::$db->queryBuilder->fetchAll();
        return ['data' => $rows, 'pagination' => $pagination];
    }

    public function get_total_pages($per_page)
    {
        $this->select();
        $rows_count = Focker::$db->queryBuilder->count();
        $pagination = Pagination::calc((int) 1, $rows_count, $per_page)['total'];
        return $pagination;
    }

    public function add_guest_post($ip, $post = null, $date = null)
    {
        $this->ip_resolution = $ip;
        $this->content = $post;
        $this->date = $date;
        $this->rubricator = 4;
        $time_to_check = TimeHelper::ONE_HOUR * 2;
        $rows = $this->check_ip($ip);
        if (!$rows) {
            $rows = parent::save();
        }
        if (is_object($rows)) {
            if ((int) $rows->date + $time_to_check < time()) {
                $rows = parent::save();
            }
        }
        if (is_array($rows)) {
            if ((int) end($rows)->date + $time_to_check < time()) {
                $rows = parent::save();
            }
        }

        return $rows;
    }

    private function check_ip($ip)
    {
        $this->select()->where('ip_resolution', $ip);
        return Focker::$db->queryBuilder->execute(null);
    }


    public function save()
    {
        $data = ['title' => '1', 'content' => 2];
        Focker::$db->queryBuilder->update('news', 'guid', 2, $data);
        $rows = Focker::$db->queryBuilder->fetchOne();
    }

    public function getLastFeaturedPost($city_id = null, $rubric = null)
    {
        $this->select()->where('guid', '(SELECT MAX(guid) FROM news WHERE type=1) ');
        if ($city_id) {
            Focker::$db->queryBuilder->andWhere('city_id', $city_id);
        }
        if ($rubric) {
            Focker::$db->queryBuilder->andWhere('rubricator', $rubric);
        }
        return Focker::$db->queryBuilder->execute();
    }

    public function getMaxId()
    {
        $this->select()->where('guid', '(SELECT MAX(guid) FROM news) ');
        return Focker::$db->queryBuilder->execute();
    }
    public function getLatestNewsOnPage($page = null, $pagination_size = 5, $order_by = "guid", $order = "DESC")
    {
        if (!$page)
            $page = 1;
        $fp_id = $this->getLastFeaturedPost()->guid;
        $this->select();
        $rows_count = Focker::$db->queryBuilder->count();
        $pagination = Pagination::calc((int) $page, $rows_count, $pagination_size);
        Focker::$db->queryBuilder->setOrder($order_by, $order);
        Focker::$db->queryBuilder->setLimits($pagination['offset'], $pagination['perPage']);
        $news = Focker::$db->queryBuilder->fetchAll();
        $last_news_on_page_id = $news[0]->guid; //there is order by pagination
        return ['page' => $page, 'fpid' => $fp_id, 'lastid' => $last_news_on_page_id];
    }



}