<?php
/*
Редакционная версия 1.
Версия лицензии 0.5.
Система модулей, в виду определённого качества и доступа - будь то парсеры, боты и прочее - 
используется для других целей - это может быть использовано в некомерческих организациях, однако уже обратно-золотно. Так как - модули - могут быть слегка не этичными. Модули свободного распространения - свободно распространяются среди коммерческих. Кроме модулей, явно предлагаемых, как продукт. Как продукт специально удовлетворяющий потребности некоммерческих организаций. Естественно - никаких регламентов не используется. Исключение - этика. Whenevere it cost, whatever it takes. 
Действующая лицензия j4l - предусматривает полное отсечение любой общей связи с GNU/GPL, в частности третьей редакции. То есть наследие, да. Остальное само собой разумеется.
Части программного обеспечения - так-же и остаются для свободного изучения, хобби,  чего угодно - что не противоречит. Главному. Здоровому интересу.
Распространяется по принципу "холодной разработки" - до момента, когда например - пример реализации хранилища версий. На решении.
Из рук-в-руки. Без третьих лиц наглых.
Код подлежит сертификации, контролю качеству и своеобразного патента код явный, авторский.
Лицензия j4l имеет алиас чпп.

Основной файл для работы с http/dom/crawling - распространяется по основной лицензии, не является модулем. Компонент модульной системы.

j4l/ЧПП 0.5, Ежегодный внеочередной пересмотр условий лицензирования.

*/
namespace Modules;

use DOMDocument;
use DOMXPath;
use Files\FileWorker;
use Helper\SystemHelper;

class Crawler
{
    public static string $raw;
    public static function makeApiRequest($url, array $with_options = null)
    {
        if (empty($with_options)) {
            $ch = curl_init($url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_HEADER, 0);
            $data = curl_exec($ch);
            curl_close($ch);
            return $data;
        } else
            return self::_makeApiRequestWithPost($url, $with_options);

    }

    public static function get_remote_page_as_dom($url): ?array
    {
        $context = self::_makeApiRequest($url);
        $dom = new DOMDocument();
        @$dom->loadHTML(SystemHelper::convert_utf8($context));
        $xpath = new DOMXPath($dom);
        return [$dom, $xpath];
    }

    public static function prepare($query_params)
    {
        return http_build_query($query_params);
    }

    private static function _makeApiRequest($url)
    {
        return file_get_contents($url);
    }

    private static function _makeApiRequestWithPost($url, $data)
    {
        $ch = curl_init();
        //  set the url
        curl_setopt($ch, CURLOPT_URL, $url);
        //  number of POST vars
        curl_setopt($ch, CURLOPT_POST, count($data));
        //  POST data
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
        //  To display result of curl
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        //  execute post
        $result = curl_exec($ch);
        //  close connection
        curl_close($ch);
        return $result;
    }
    public static function serialize_data($data)
    {

    }
    public static function deserialize_data($data)
    {
        $data = json_decode($data, true);
        return $data;
    }

    public static function get_input()
    {
        $data = file_get_contents('php://input');
        self::$raw = $data;
        return self::deserialize_data($data);
    }
}