<?php
/*
Редакционная версия 1.
Версия лицензии 0.5.
Система модулей, в виду определённого качества и доступа - будь то парсеры, боты и прочее - 
используется для других целей - это может быть использовано в некомерческих организациях, однако уже обратно-золотно. Так как - модули - могут быть слегка не этичными. Модули свободного распространения - свободно распространяются среди коммерческих. Кроме модулей, явно предлагаемых, как продукт. Как продукт специально удовлетворяющий потребности некоммерческих организаций. Естественно - никаких регламентов не используется. Исключение - этика. Whenevere it cost, whatever it takes. 
Действующая лицензия j4l - предусматривает полное отсечение любой общей связи с GNU/GPL, в частности третьей редакции. То есть наследие, да. Остальное само собой разумеется.
Части программного обеспечения - так-же и остаются для свободного изучения, хобби,  чего угодно - что не противоречит. Главному. Здоровому интересу.
Распространяется по принципу "холодной разработки" - до момента, когда например - пример реализации хранилища версий. На решении.
Из рук-в-руки. Без третьих лиц наглых.
Код подлежит сертификации, контролю качеству и своеобразного патента код явный, авторский.
Лицензия j4l имеет алиас чпп.
j4l/ЧПП 0.5, Ежегодный внеочередной пересмотр условий лицензирования.

*/
namespace Modules\Kant;

use Helper\Enums;
use Modules\Crawler;
use Modules\Modules;


class Kant extends Modules
{
    const AUTHOR = "xorx";
    const MODULE_NAME = "Kant";
    const DESC = "Kant - модуль для работы с vk.com/api";
    const LICENSE = Enums::DISTRIBUTION_BOTH_FREE;
    private string $_api_key, $_api_url, $_last_action, $_logs_dir, $_log_file, $_api_version = '5.87';
    public bool $webhooked = false, $standalone = false;
    public function __construct(string $api_key, bool $standalone = false, $api_url = 'https://api.vk.com/method/')
    {
        parent::__construct(Kant::AUTHOR, Kant::MODULE_NAME);
        $this->_api_key = $api_key;
        $this->_api_url = $api_url;
        $this->standalone = $standalone;
        $this->_logs_dir = __DIR__ . '/cath/';
        $this->_log_file = $this->_logs_dir . 'log.smg';
    }

    public function sendMessage($opcode, $to, $message)
    {
        $request_params = array(
            'message' => urldecode($message),
            'peer_id' => $to,
            'access_token' => $this->_api_key,
            'v' => $this->_api_version
        );
        $request_params = Crawler::prepare($request_params);
        $query = $this->_api_url . $opcode . $request_params;
        return Crawler::makeApiRequest($query);
    }

}
