<?php
/*
Редакционная версия 1.
Версия лицензии 0.5.
Система модулей, в виду определённого качества и доступа - будь то парсеры, боты и прочее - 
используется для других целей - это может быть использовано в некомерческих организациях, однако уже обратно-золотно. Так как - модули - могут быть слегка не этичными. Модули свободного распространения - свободно распространяются среди коммерческих. Кроме модулей, явно предлагаемых, как продукт. Как продукт специально удовлетворяющий потребности некоммерческих организаций. Естественно - никаких регламентов не используется. Исключение - этика. Whenevere it cost, whatever it takes. 
Действующая лицензия j4l - предусматривает полное отсечение любой общей связи с GNU/GPL, в частности третьей редакции. То есть наследие, да. Остальное само собой разумеется.
Части программного обеспечения - так-же и остаются для свободного изучения, хобби,  чего угодно - что не противоречит. Главному. Здоровому интересу.
Распространяется по принципу "холодной разработки" - до момента, когда например - пример реализации хранилища версий. На решении.
Из рук-в-руки. Без третьих лиц наглых.
Код подлежит сертификации, контролю качеству и своеобразного патента код явный, авторский.
Лицензия j4l имеет алиас чпп.
j4l/ЧПП 0.5, Ежегодный внеочередной пересмотр условий лицензирования.

*/
namespace Modules\Pregol\Branches;

class Right
{
    public ?string $query = null;
    public function __construct()
    {
        $this->query = '';
    }

    public function begin(): ?Right
    {
        $this->query = '//';
        return $this;
    }

    public function tag(string $elementName): Right
    {
        $this->query .= $elementName;
        return $this;
    }

    public function class (string $className): Right
    {
        $query = sprintf('[@class="%s"]', $className);
        $this->query .= $query;
        return $this;
    }

    public function id(string $id): Right
    {
        $query = sprintf('[@id="%s"]', $id);
        $this->query .= $query;
        return $this;
    }

    public function drown(): Right
    {
        $this->query .= '/';
        return $this;
    }

    public function all(): Right
    {
        $this->query .= '*';

        return $this;
    }

    public function links(): Right
    {
        $this->query .= 'a';

        return $this;
    }



}